/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelAlerts = {};
panelAlerts.localization = {};
/****************************/

// Panel details
var panelName = "Alerts";
var _panel = $("#pnl" + panelName);

// Localizations
panelAlerts.localization = {
	headerText : ""
	, pnlDescText : "Alerts allow for automatic notifications when specific server events occur."
	, btnAddText : "Add"
	, btnCopyText : "Copy"
	, btnRemoveText : "Remove"
	, lblAlertTypeText : "Alert Type : "
	, lblSecondsIntervalText : "Seconds interval : "
	, lblLoginCountText : "Login count : "
	, lblPercentageOfQuotaTobeReachedText : "Percentage of quota to be reached for this alert : "
	, lblDriveText : "Drive : "
	, lblThresholdInMBText : "Threshold in MB : "
	, lblEmailText : "Email"
	, lblEmailMaxOfText : "Max of : "
	, lblEmailDurationText : "emails per hour"
	, lblEmailFromText : "From : "
	, lblEmailToText : "To : "
	, lblEmailCCText : "CC : "
	, lblEmailBCCText : "BCC : "
	, lblEmailSubjectText : "Subject : "
	, lblEmailBodyText : "Body : "
	, btnResetText : "Reset All Prefs to Default"
	, btnCancelText : "Cancel"
	, btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelAlerts.localization, localizations.panels[panelName]);

// Interface methods
panelAlerts.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelAlerts.localization.Header, true);
	panelAlerts.bindData();
	panelAlerts.bindEvents();
}

panelAlerts.bindData = function()
{
	var prefs = $(document).data("GUIXMLPrefs");
	bindValuesFromXML(_panel, prefs);
	if(prefs && prefs["alerts"])
	{
		var alerts = prefs["alerts"];
		if(alerts.length>0)
		{
			alerts = alerts[0]["alerts_subitem"];
			if(alerts)
			{
				var alertsList = $("#alerts", _panel);
				var selected = alertsList.find("li.ui-widget-header").index();
				alertsList.empty();
				for(var i=0;i<alerts.length;i++)
				{
					var curItem = alerts[i];
					if(curItem && curItem.type)
					{
						var type = getTextValueFromXMLNode(curItem.type, "");
						var newControl = $("<li class='ui-widget-content' alertType='"+type+"'>"+type+"</li>");
						alertsList.append(newControl);
						newControl.data("controlData", curItem);
					}
				}
				if(selected>=0)
				{
					selected += 1;
					panelAlerts.bindFormDetails(alertsList.find("li:nth-child("+selected+")").addClass("ui-widget-header"));
				}
			}
		}
	}
}

panelAlerts.bindEvents = function()
{
	var alerts = $("#alerts", _panel);
	alerts.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			panelAlerts.bindFormDetails(selected);
			return false;
		}
	});

	_panel.find("select#type").change(function(){
		panelAlerts.showFieldsBasedOnType($(this).val());
	});

	$("a#addAlert", _panel).click(function(){
		common.UI.addItem($("#alerts", _panel)
						, $("<li class='ui-widget-content'>No Action</li>")
						, {
							cc:[{text:""}],
							quota_perc:[{text:""}],
							login_count:[{text:""}],
							max_alert_emails:[{text:"60"}],
							body:[{text:""}],
							bcc:[{text:""}],
							type:[{text:"No Action"}],
							subject:[{text:""}],
							from:[{text:""}],
							to:[{text:""}],
							threshold_mb:[{text:""}],
							drive:[{text:""}],
							login_interval:[{text:"60"}]
						}
						, panelAlerts.bindFormDetails);
						itemsChanged(true);
		return false;
	});

	$("a#copyAlert", _panel).click(function(){
		common.UI.copyItem($("#alerts", _panel).find("li.ui-selected"), panelAlerts.bindFormDetails);
		itemsChanged(true);
		return false;
	});

	$("a#removeAlert", _panel).click(function(){
		common.UI.removeItem($("#alerts", _panel), panelAlerts.bindFormDetails);
		itemsChanged(true);
		return false;
	});

	var formDetailsPanel  = $("#formDetailsPanel", _panel);
	formDetailsPanel.find("input, select, textarea").bind("change", function(){
		var item = alerts.find("li.ui-selected");
		if(!item || item.length==0)return;
		var data = item.data("controlData");
		if(data)
		{
			var isBool = $(this).attr("type") == "radio" || $(this).attr("type") == "checkbox";
			data[$(this).attr("id")] = [{text: isBool ? $(this).is(":checked").toString() : $(this).val()}];
			if($(this).attr("id") == "type")
			{
				item.text($(this).val());
			}
		}
		item.data("controlData", data);
		itemsChanged(true);
	});

	formDetailsPanel.find("input[type='text'], textarea").bind("textchange", function(){
		var item = alerts.find("li.ui-selected");
		if(!item || item.length==0)return;
		var data = item.data("controlData");
		if(data)
		{
			var isBool = $(this).attr("type") == "radio" || $(this).attr("type") == "checkbox";
			data[$(this).attr("id")] = [{text: isBool ? $(this).is(":checked").toString() : $(this).val()}];
			if($(this).attr("id") == "type")
			{
				item.text($(this).val());
			}
		}
		item.data("controlData", data);
		itemsChanged(true);
	});
}

panelAlerts.bindFormDetails = function(alertList)
{
	if(!alertList)
	{
		$("#formDetailsPanel", _panel).hide();
		return;
	}
	var controlData = $(alertList).data("controlData");
	var formDetailsPanel = $("#formDetailsPanel", _panel).show();
	var type = getTextValueFromXMLNode(controlData.type, "");
	panelAlerts.showFieldsBasedOnType(type);
	var inputs = formDetailsPanel.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(formDetailsPanel, controlData);
	inputs.addClass("ignoreBind");
}

panelAlerts.showFieldsBasedOnType = function(type)
{
	type = type || _panel.find("select#type").val();
	$(".hammeringSpecific,.quotaReachedSpecific,.diskSpaceBelowThresholdSpecific", _panel).hide();
	if(type == "User Hammering")
	{
		$(".hammeringSpecific", _panel).show();
	}
	else if(type == "User reached quota percentage")
	{
		$(".quotaReachedSpecific", _panel).show();
	}
	else if(type == "Disk Space Below Threshold")
	{
		$(".diskSpaceBelowThresholdSpecific", _panel).show();
	}
}

panelAlerts.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		common.UI.showIndicator(false, false, "Please wait..");
		var xmlString = [];
		var formAlertsList = $("#alerts", _panel).find("li");
		if(formAlertsList.length>0)
		{
			xmlString.push("<alerts type=\"vector\">");
			formAlertsList.each(function(){
				xmlString.push("<alerts_subitem type=\"properties\">");
				var controlData = $(this).data("controlData");
				for(var item in controlData)
				{
					if(controlData[item].length)
					{
						if(controlData[item][0].text)
						{
							xmlString.push("<"+item+">"+common.methods.htmlEncode(controlData[item][0].text)+"</"+item+">");
						}
					}
				}
				xmlString.push("</alerts_subitem>");
			});
			xmlString.push("</alerts>");
		}
		var formSubItem = xmlString.join("\n");
		var action = xmlString.length>0 ? "reset" : "remove";
		common.data.setXMLPrefs("server_settings/alerts/0"
			, "vector"
			, action
			, formSubItem
			, function(data){
				data = $.xml2json(data, true);
				if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
				{
					common.data.updateLocalPrefs(function(){
						common.UI.hideIndicator();
						growl("Data saved", "Your changes are saved", false, 5000);
						placeHolder.removeData("hasChanged");
						panelAlerts.bindData();
					});
				}
				else
				{
					growl("Error while saving", "Your changes are not saved", true);
				}
			}
		);
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}