/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelBanning = {};
panelBanning.localization = {};
/****************************/

// Panel details
var panelName = "Banning";
var _panel = $("#pnl" + panelName);

// Localizations
panelBanning.localization = {
	headerText : "",
	lblHammeringConnectionSettingsText : " Hammering Connection Settings: ",
	lblConnectionSettingMaximumOfText : "Maximum of",
	lblConnectionSettingAttemptsInText : "attempts in",
	lblConnectionSettingSecondsThenBannedForText : "seconds, then banned for",
	lblConnectionSettingMinutesText : "minutes.",
	lblHammeringCommandSettingsText : " Hammering Command Settings: ",
	lblConnectionSettingMaximumOfText : "Maximum of",
	lblConnectionSettingAttemptsInText : "attempts in",
	lblConnectionSettingSecondsThenBannedForText : "seconds, then banned for",
	lblConnectionSettingMinutesText : "minutes.",
	lblHammeringPasswordSettingsText : " Hammering Password Settings: ",
	lblConnectionSettingMaximumOfText : "Maximum of",
	lblConnectionSettingAttemptsInText : "attempts in",
	lblConnectionSettingSecondsThenBannedForText : "seconds, then banned for",
	lblConnectionSettingMinutesText : "minutes.",
	lblHackAttemptSettingsText : " Hack Attempt Settings: ",
	lblHackAttemptSettingNoteText : "If any of these usernames are attempted, then banned for",
	lblConnectionSettingMinutesText : "minutes.",
	lblIPRestrictionsAndBansText : " IP Restrictions and Bans: ",
	btnRestrictionsRemoveText : " Remove ",
	btnRestrictionsEditText : " Edit ",
	btnRestrictionsAddText : " Add ",
	lblIPRestrictionsAndBansNoteText : " An empty list will deny everyone. ",
	lblIPRestrictionsAndBansNeverBanIPsText : " Never ban these IPs: ",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelBanning.localization, localizations.panels[panelName]);

// Interface methods
panelBanning.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelBanning.localization.Header, true);
	panelBanning.bindData();
	panelBanning.bindEvents();
}

panelBanning.bindData = function()
{
	var prefs = $(document).data("GUIXMLPrefs");
	bindValuesFromXML(_panel, prefs);
	if(prefs["ip_restrictions"])
	{
		var bannedIPList = prefs["ip_restrictions"];
		if(bannedIPList.length>0)
		{
			bannedIPList = bannedIPList[0]["ip_restrictions_subitem"];
			var formbannedIPList = $("#bannedIPlist", _panel);
			for(var i=0;i<bannedIPList.length;i++)
			{
				var curItem = bannedIPList[i];
				if(curItem)
				{
					var type = getTextValueFromXMLNode(curItem.type, "");
					var startip = getTextValueFromXMLNode(curItem.start_ip, "");
					var stopip = getTextValueFromXMLNode(curItem.stop_ip, "");
					var bannedIP = type + startip + ", " + stopip;
					var newControl = $("<li class='ui-widget-content' bannedIP='"+bannedIP+"'>"+bannedIP+"</li>");
					formbannedIPList.append(newControl);
					newControl.data("controlData", curItem);
				}
			}
		}
	}
}

panelBanning.bindEvents = function()
{
	var formbannedIPList = $("#bannedIPlist", _panel);
	formbannedIPList.selectableAdvanced({
		select: function(event, ui) {
			var selected = $(ui.selection);
			selected.parent().find(".ui-state-highlight").removeClass("ui-state-highlight");
			return false;
		},
		change: function(event, ui) {
			var selected = $(ui.selection).filter(":last");
			selected.parent().find(".ui-state-highlight").removeClass("ui-state-highlight");
			return false;
		},
		remove : function(event, ui) {
			$("a#removeBanRule", _panel).click();
			return false;
		},
		callOnSelection : function(itemLi)
		{
			/*var top_val = itemLi.offset().top - itemLi.closest("div").height();
			itemLi.closest("div").animate({
				scrollTop: top_val - 200
			}, 0);*/
		}
	});

	$("a#addNewBanRule", _panel).click(function(evt){
		var beforeAfter =  "";
		jPrompt("Insert before/after selection?", beforeAfter, "CrushFTP IP Insert", function(value){
			beforeAfter = value;
			if(beforeAfter != null)
			{
				var allowDeny = "";
				function allowDenyEntry()
				{
					jPrompt("Choose one :", allowDeny, "CrushFTP IPs", function(value){
						allowDeny = value;
						if(allowDeny == null)return false;
						if(allowDeny)
						{
							var startIP = "";
							function startIPEntry()
							{
								jPrompt("Please enter a starting IP:", startIP, "CrushFTP IPs", function(value){
									startIP = value;
									if(startIP == null)return false;
									if(!isValidIP(startIP))
									{
										jAlert("Invalid starting IP - Address!!", "Message", function(){
										startIPEntry();
										});
									}
									else
									{
										var stopIP = startIP;
										function stopIPEntry()
										{
											jPrompt("Please enter a stopping IP:", stopIP, "CrushFTP IPs", function(value){
												stopIP = value;
												if(stopIP == null)return false;
												if(!isValidIP(stopIP))
												{
													jAlert("Invalid stopping IP - Address!!", "Message", function(){
													stopIPEntry();
													});
												}
												else
												{
													var formbannedIPList = $("#bannedIPlist", _panel);
													var bannedIP = allowDeny + startIP + ", " + stopIP;
													var newControl = $("<li class='ui-widget-content' bannedIP='"+bannedIP+"'>"+bannedIP+"</li>");
													newControl.data("controlData", {
														start_ip:[{text:startIP}],
														type:[{text:allowDeny}],
														stop_ip:[{text:stopIP}]
													});

													if(beforeAfter == "After")
													{
														formbannedIPList.append(newControl);
													}
													else
													{
														formbannedIPList.prepend(newControl);
													}

													if(newControl)
													{
														newControl.addClass("ui-widget-content ui-selectable-item");
														formbannedIPList.selectableAdvanced("refresh");
														itemsChanged(true);
													}
												}
											});
										}
										stopIPEntry();
									}
								});
							}
							startIPEntry();
						}
						else if(fieldName != null)
						{
							allowDenyEntry();
						}
					}, ["A|Allow", "D|Deny", "D|Ban"]);
				}
				allowDenyEntry();
			}
		}, ["Before", "After"]);
		return false;
	});

	$("a#removeBanRule", _panel).click(function(){
		common.UI.removeItem($("#bannedIPlist", _panel));
		formbannedIPList.selectableAdvanced("refresh");
		itemsChanged(true);
		return false;
	});

	$("a#editBanRule", _panel).click(function(evt, control){
		var formbannedIPList = $("#bannedIPlist", _panel);
		var selected = formbannedIPList.find("li.ui-selected:last");
		if(selected && selected.length > 0)
		{
			selected.parent().find(".ui-state-highlight").removeClass("ui-state-highlight");
			selected.addClass("ui-state-highlight");
			var controlData = selected.data("controlData");
			if(!controlData)return;
			var allowDeny = getTextValueFromXMLNode(controlData.type, "");
			function allowDenyEntry()
			{
				jPrompt("Choose one :", allowDeny, "CrushFTP IPs", function(value){
					allowDeny = value;
					if(allowDeny)
					{
						var startIP = getTextValueFromXMLNode(controlData.start_ip, "");
						function startIPEntry()
						{
							jPrompt("Please enter a starting IP:", startIP, "CrushFTP IPs", function(value){
								startIP = value;
								if(value)
								{
									if(!isValidIP(startIP))
									{
										jAlert("Invalid starting IP - Address!!", "Message", function(){
										startIPEntry();
										});
									}
									else
									{
										var stopIP = getTextValueFromXMLNode(controlData.stop_ip, "");
										function stopIPEntry()
										{
											jPrompt("Please enter a stopping IP:", stopIP, "CrushFTP IPs", function(value){
												stopIP = value;
												if(!isValidIP(stopIP))
												{
													jAlert("Invalid stopping IP - Address!!", "Message", function(){
													stopIPEntry();
													});
												}
												else
												{
													var formbannedIPList = $("#bannedIPlist", _panel);
													var bannedIP = allowDeny + startIP + ", " + stopIP;
													var newControl = $("<li class='ui-widget-content' bannedIP='"+bannedIP+"'>"+bannedIP+"</li>");
													selected.replaceWith(newControl);
													newControl.data("controlData", {
														start_ip:[{text:startIP}],
														type:[{text:allowDeny}],
														stop_ip:[{text:stopIP}]
													});
													if(newControl)
													{
														newControl.addClass("ui-widget-content ui-selectable-item");
														formbannedIPList.selectableAdvanced("refresh");
														itemsChanged(true);
													}
												}
											});
										}
										stopIPEntry();
									}
								}
							});
						}
						startIPEntry();
					}
					else if(allowDeny != null)
					{
						allowDenyEntry();
					}
				}, ["A|Allow", "D|Deny", "D|Ban"]);
			}
			allowDenyEntry();
		}
		return false;
	});
}

panelBanning.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		var hackUsers = $("#hack_usernames", _panel).val().toLowerCase().split(",");
		for(var i=0;i<hackUsers.length;i++)
		{
			var curUser = $.trim(hackUsers[i]);
			if(curUser=="anonymous")
			{
				alert("You can not add 'Anonymous' user to ban in hack attemt setting");
				$("#hack_usernames", _panel).focus();
				return false;
			}
		}
		common.UI.showIndicator(false, false, "Please wait..");
		var prefsToSave = '<server_prefs type="properties">'+buildXMLToSubmitForm(_panel)+'</server_prefs>';
		common.data.setXMLPrefs("server_settings/server_prefs/", "properties", "update", prefsToSave, function(data){
			data = $.xml2json(data, true);
			if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
			{
				var xmlData = panelBanning.buildXMLData(_panel);
				common.data.setXMLPrefs("server_settings/ip_restrictions/0", "vector", "reset", xmlData, function(data){
					data = $.xml2json(data, true);
					if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
					{
						common.data.updateLocalPrefs(function(){
							common.UI.hideIndicator();
							growl("Data saved", "Your changes are saved", false, 5000);
							placeHolder.removeData("hasChanged");
						});
					}
					else
					{
						growl("Error while saving", "Your changes are not saved", true);
					}
				});
			}
			else
			{
				common.UI.hideIndicator();
				growl("Error while saving", "Your changes are not saved", true);
			}
		});
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}

panelBanning.buildXMLData = function()
{
	var ip_restrictions = "<ip_restrictions type=\"vector\">";
	var formbannedIPList = $("#bannedIPlist", _panel);
	formbannedIPList.find("li").each(function(){
		var curData = $(this).data("controlData");
		if(curData)
		{
			ip_restrictions += "<ip_restrictions_subitem type=\"properties\">";
			ip_restrictions += "<start_ip>"+common.methods.htmlEncode(getTextValueFromXMLNode(curData.start_ip, ""))+"</start_ip>";
			ip_restrictions += "<type>"+common.methods.htmlEncode(getTextValueFromXMLNode(curData.type, ""))+"</type>";
			ip_restrictions += "<stop_ip>"+common.methods.htmlEncode(getTextValueFromXMLNode(curData.stop_ip, ""))+"</stop_ip>";
			ip_restrictions += "</ip_restrictions_subitem>";
		}
	});
	ip_restrictions += "</ip_restrictions>";
	return ip_restrictions;
}