/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelLogging = {};
panelLogging.localization = {};
/****************************/

// Panel details
var panelName = "Logging";
var _panel = $("#pnl" + panelName);

// Localizations

panelLogging.localization = {
	headerText : "",
	lblSettingsTabText : "Settings",
	lblServerWindowOptionsTabText : "Server Window Options",
	lblLogFileOptionsTabText : "Log File Options",
	lblLogToDiskText : "Log to Disk",
	lblUseExtendedLoggingText : "Use extended (Syslog, DB, Mail, etc.)",
	lblUseConfigurationFileText : "Use configuration file from \"conf/logging.xml\"",
	lblEnableLogRollingText : "Enable Log Rolling",
	lblMaxSizeBeforeRollingText : "Max size before rolling : ",
	lblKeepHowManyFilesText : "Keep how many files : ",
	lblKeepHowManyFilesNoteText : "(0 = no limit)",
	lblEnableDailyLogRollingText : "Enable Daily Log Rolling",
	lblServerWindowLogBufferText : "Server Window Log Buffer : ",
	lblLinesText : "lines",
	lblUserInfoLogBufferText : "User Window Log Buffer : ",
	lblLinesText : "lines",
	lblUserLogFileLocationText : "Log File Location and Name : ",
	lblLogMatchingPatternText : "Filter log messages matching these pattern : ",
	lblErrorAndExceptionsText : "Errors and Exceptions",
	lblServerStoppedText : "Server Stopped",
	lblUserKickedText : "User Kicked",
	lblUserConnectedText : "User Connected",
	lblHTTPPostText : "HTTP POST",
	lblHTTPDeleteText : "HTTP DELETE",
	lblHTTPMoveText : "HTTP MOVE",
	lblHelpCommandText : "Help Command",
	lblRNTOCommandText : "RNTO Command",
	lblRMDCommandText : "RMD Command",
	lblRETRCommandText : "RETR Command",
	lblPASVCommandText : "PASV Command",
	lblEPRTCommandText : "EPRT Command",
	lblPROTCommandText : "PROT Command",
	lblSIZECommandText : "SIZE Command",
	lblRESTCommandText : "REST Command",
	lblSTORCommandText : "STOR Command",
	lblLISTCommandText : "LIST Command",
	lblWebInterfaceCommandText : "WebInterface Commands",
	lblDeniedConnectionsText : "Denied Connections",
	lblCrushFTPStartedText : "CrushFTP Started",
	lblUserBannedText : "User Banned",
	lblUserDisconnectedText : "User Disconnected",
	lblHTTPPropfindText : "HTTP PROPFIND",
	lblHTTPMkColText : "HTTP MKCOL",
	lblUserPauseResumeText : "User Pause / Resume",
	lblUSERCommandText : "USER Command",
	lblPWDCommandText : "PWD Command",
	lblMACBCommandText : "MACB Command",
	lblNLSTCommandText : "NLST Command",
	lblPORTCommandText : "PORT Command",
	lblAUTHCommandText : "AUTH Command",
	lblSYSTCommandText : "SYST Command",
	lblMDTMCommandText : "MDTM Command",
	lblDELECommandText : "DELE Command",
	lblAPPECommandText : "APPE Command",
	lblDirectoryListingsText : "Directory Listings",
	lblSITECommandText : "SITE Command",
	lblServerStartedText : "Server Started",
	lblCrushFTPQuitText : "CrushFTP Quit",
	lblDateTimeText : "Date / Time",
	lblHTTPGetText : "HTTP GET",
	lblHTTPLockText : "HTTP LOCK",
	lblHTTPPutText : "HTTP PUT",
	lblSTATCommandText : "STAT Command",
	lblRNFRCommandText : "RNFR Command",
	lblCWDCommandText : "CWD Command",
	lblABORCommandText : "ABOR Command",
	lblCDUPCommandText : "CDUP Command",
	lblEPSVCommandText : "EPSV Command",
	lblPBSZCommandText : "PBSZ Command",
	lblNOOPCommandText : "NOOP Command",
	lblTYPECommandText : "TYPE Command",
	lblMKDCommandText : "MKD Command",
	lblSTOUCommandText : "STOU Command",
	lblProxyDataText : "Proxy Data",
	lblQUITCommandText : "QUIT Command",
	lblLogDebugLevelText : "Log Debug Level :",
	lblDebugLevelNoteText : "Level 1 :  Revealing informational errors, Level 2 : Verbose",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelLogging.localization, localizations.panels[panelName]);

// Interface methods
panelLogging.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelLogging.localization.Header, true);
	panelLogging.bindData();
}

panelLogging.bindData = function()
{
	var prefs = $(document).data("GUIXMLPrefs");
	bindValuesFromXML(_panel, prefs);
	var window_log_allow_str = getTextValueFromXMLNode(prefs.window_log_allow_str, "");
	window_log_allow_str = window_log_allow_str.split(")");
	for(var item in window_log_allow_str)
	{
		var curItem = window_log_allow_str[item];
		if(curItem.length>0 && curItem.substr)
		{
			curItem = curItem.substr(1, curItem.length);
			curItem = curItem.toLowerCase();
			if(curItem && curItem.length>0)
			{
				checkUnchekInput($("#w_"+curItem, _panel), true);
			}
		}
	}

	var log_allow_str = getTextValueFromXMLNode(prefs.log_allow_str, "");
	log_allow_str = log_allow_str.split(")");
	for(var item in log_allow_str)
	{
		var curItem = log_allow_str[item];
		if(curItem.length>0 && curItem.substr)
		{
			curItem = curItem.substr(1, curItem.length);
			curItem = curItem.toLowerCase();
			if(curItem && curItem.length>0)
			{
				checkUnchekInput($("#"+curItem, _panel), true);
			}
		}
	}
}

panelLogging.bindEvents = function()
{

}

panelLogging.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		common.UI.showIndicator(false, false, "Please wait..");
		var xmlData = '<server_prefs type="properties">'+panelLogging.buildXMLData(_panel)+'</server_prefs>';
		common.data.setXMLPrefs("server_settings/server_prefs/", "properties", "update", xmlData, function(data){
			data = $.xml2json(data, true);
			if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
			{
				common.data.updateLocalPrefs(function(){
					common.UI.hideIndicator();
					growl("Data saved", "Your changes are saved", false, 5000);
					placeHolder.removeData("hasChanged");
				});
			}
			else
			{
				growl("Error while saving", "Your changes are not saved", true);
			}
		});
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}

panelLogging.buildXMLData = function()
{
	var xmlString = buildXMLToSubmitForm(_panel);

	var window_log_allow_str = "";
	$("input:checked", _panel.find("#LogingServerOptions")).each(function(){
		window_log_allow_str += "(" + $(this).attr("id").replace("w_","").toUpperCase() + ")";
	});
	xmlString += "\r\n<window_log_allow_str>" + common.methods.htmlEncode(window_log_allow_str) + "</window_log_allow_str>";

	var log_allow_str = "";
	$("input:checked", _panel.find("#LogingLogFileOptions")).each(function(){
		log_allow_str += "(" + $(this).attr("id").toUpperCase() + ")";
	});
	xmlString += "\r\n<log_allow_str>" + common.methods.htmlEncode(log_allow_str) + "</log_allow_str>";
	return xmlString;
}