/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelPlugins = {};
panelPlugins.localization = {};
/****************************/

// Panel details
var panelName = "Plugins";
var _panel = $("#pnl" + panelName);
var _pluginsList = $("#pluginsList", _panel);

panelPlugins.pluginsToIgnore = ["WebStatistics", "CrushImagePreview", "CrushLDAP", "DotBin", "FilterCommand", "HiddenFTP", "MiniUrlManager", "OSXNetInfo", "DebugOptions"];

// Localizations
panelPlugins.localization = {
	headerText : " Plugins ",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelPlugins.localization, localizations.panels[panelName]);

// Interface methods
panelPlugins.init = function(pluginToLoad, refresh, pluginID, returnXML){
	panelPlugins.isEmbed = pluginToLoad && pluginToLoad.length>0;
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelPlugins.localization.Header, true);
	if(panelPlugins.isEmbed)
	{
		panelPlugins.loadPlugin(pluginToLoad, refresh, pluginID, returnXML);
		$(".nonEmbed", _panel).hide();
		var data = $(document).data("PluginBindData" + pluginID);
		if(data.hideButtons)
		{
			$(".buttonsPanel", _panel).hide();
		}
	}
	else
	{
		panelPlugins.bindData();
		panelPlugins.bindEvents();
	}
}

panelPlugins.bindData = function()
{
	var prefs = $(document).data("GUIXMLPrefs");
	bindValuesFromXML(_panel, prefs);
	if(!panelPlugins.isEmbed && prefs && prefs["plugins"])
	{
		var plugins = prefs["plugins"];
		if(plugins.length>0)
		{
			plugins = plugins[0]["plugins_subitem"];
			if(plugins)
			{
				for(var i=0;i<plugins.length;i++)
				{
					var curItem = plugins[i];
					curItem = curItem["plugins_subitem_subitem"];
					if(curItem)
					{
						if(curItem.length>0 && curItem[0].pluginName)
						{
							var name = getTextValueFromXMLNode(curItem[0].pluginName, "");
							if(panelPlugins.pluginsToIgnore.indexOf(name)<0)
							{
								var newControl = $("<option>"+name+"</option>");
								_pluginsList.append(newControl);
								newControl.data("controlData", curItem);
							}
						}
					}
				}
			}
		}
	}
}

panelPlugins.getPluginIndex = function(plugin)
{
	if(panelPlugins.isEmbed) return 0;
	var prefs = $(document).data("GUIXMLPrefs");
	if(prefs && prefs["plugins"])
	{
		var plugins = prefs["plugins"];
		if(plugins.length>0)
		{
			plugins = plugins[0]["plugins_subitem"];
			if(plugins)
			{
				for(var i=0;i<plugins.length;i++)
				{
					var curItem = plugins[i];
					curItem = curItem["plugins_subitem_subitem"];
					if(curItem)
					{
						if(curItem.length>0 && curItem[0].pluginName)
						{
							var name = getTextValueFromXMLNode(curItem[0].pluginName, "");
							if(name == plugin)
							return i;
						}
					}
				}
			}
		}
	}
	return false;
}

panelPlugins.bindEvents = function()
{
	_pluginsList.bind("change", function(){
		panelPlugins.loadPlugin($(this).val());
	}).val("AutoUnzip").trigger("change");

	//.keyup(function(){$(this).trigger("change");})

	$(".buttonAddClone", _panel).unbind("click").click(function(){
		var cloneName = window.currentPlugin;
		var subItemIndex = _plugin.data("subItem") || 0;
		if(subItemIndex>0)
		{
			var pluginName = window.currentPlugin;
			var pluginPrefs = common.data.getPluginPrefs(pluginName);
			if(pluginPrefs && pluginPrefs.length>0 && pluginPrefs[subItemIndex])
			{
				cloneName = pluginPrefs[subItemIndex].subItem[0].text || cloneName;
			}
		}
		cloneName = cloneName || "";
		cloneName = cloneName.toString();
		cloneName = unescape(cloneName) + " clone";
		jPrompt("Please enter a name for this plugin clone :", cloneName, "Input", function(value){
			cloneName = value;
			if(cloneName!=null)
			{
				if(cloneName.length == 0)
				{
					$(".buttonAddClone", _panel).trigger("click");
					return;
				}
				panelPlugins.addPluginClone(cloneName.toString());
			}
		});
	});

	$(".buttonRemoveClone", _panel).unbind("click").click(function(){
		var subItemIndex = _plugin.data("subItem") || 0;
		if(subItemIndex>0)
		{
			var pluginName = window.currentPlugin;
			var pluginPrefs = common.data.getPluginPrefs(pluginName);
			if(pluginPrefs && pluginPrefs.length>0 && pluginPrefs[subItemIndex])
			{
				var tabName = pluginPrefs[subItemIndex].subItem[0].text || "";
				var isAtServer = false;
				if(_panel.find(".subPluginTabHandler").length>0)
				{
					tabAnchors = _plugin.prev();
					var tab = tabAnchors.find("button[pluginIndex='"+subItemIndex+"']");
					isAtServer = $(tab).attr("atServer") || false;
				}
				jConfirm("Are you sure you wish to remove this item \""+unescape(tabName)+"\"?", "Confirm", function(value){
					if(value)
					{
						panelPlugins.removePluginClone(subItemIndex, isAtServer);
					}
				});
			}
		}
		else
		{
			jAlert("You can not remove the base plugin instance.", "Alert", false);
		}
	});
}

panelPlugins.loadPlugin = function(plugin, refresh, pluginID, returnXML)
{
	if((plugin && window.currentPlugin != plugin) || refresh)
	{
		window.pluginPlaceHolder = $("#pluginContainer");
		function continueLoading()
		{
			common.UI.showIndicator(false);
			notification(false);
			pluginPlaceHolder.load(window.panelPath + "Plugins/"+plugin+"/index.html?random="+Math.random(), function(response, status, xhr) {
			  $("#vtip").remove();
			  if (status == "error") {
				var msg = "Sorry but there was an error: " + xhr.status + " " + xhr.statusText + " while loading plugin : " + plugin;
				notification(msg, true);
				common.UI.hideIndicator(false);
				if(!panelPlugins.isEmbed)
				{
					_pluginsList.val(window.currentPlugin);
				}
				else
				{
					pluginPlaceHolder.html("<div style='padding:5px;'>"+msg+"</div>");
					pluginPlaceHolder.find("div").addClass("ui-state-error").prepend('<span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-alert"></span>');
				}
				window.currentPluginIndex = panelPlugins.getPluginIndex(window.currentPlugin);
			  }
			  else
			  {
				common.UI.showIndicator(false);
				buildButtons(pluginPlaceHolder);
				$(".tabs", pluginPlaceHolder).tabs();
				$.getScript(window.panelPath + "Plugins/"+plugin+"/interface.js?random="+Math.random(), function() {
					var initScript = "plugin" + plugin + ".init();";
					if(pluginID)
					{
						initScript = "plugin" + plugin + ".init('"+pluginID+"', "+returnXML+");";
					}
					try{
						common.UI.hideIndicator(false);
						eval(initScript);
						window.currentPlugin = plugin;
						window.currentPluginIndex = panelPlugins.getPluginIndex(window.currentPlugin);
						panelPlugins.initLayoutEvents(pluginPlaceHolder, plugin, pluginID);
					}
					catch(ex){
						if(ex && ex.toString() != "")
						{
							growl("Error", ex, true);
						}
					}
				});
			  }
			});
		}
		if(pluginPlaceHolder.data("hasChanged") && !returnXML)
		{
			jConfirm("If you navigate away, you will loose your unsaved changes. Do you want to continue?", "Confirm", function(value){
				if(value)
				{
					continueLoading();
				}
			});
		}
		else
		{
			continueLoading();
		}
	}
	return false;
}

panelPlugins.initLayoutEvents = function(context, plugin, pluginID)
{
	var pluginName = window.currentPlugin;
	if(pluginName && window.panelEvents)
		window.panelEvents.updatePluginControlData(pluginName, true);
	var _plugin = $("#pnlPlugin" + pluginName);
	var pluginPrefs = [];
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	_plugin.data("subItem",0);
	if(pluginPrefs && pluginPrefs.length>0)
	{
		var pluginContainer = false;
		var tabAnchors = false;
		var multipleInstance = pluginPrefs.length>1;
		if(multipleInstance)
		{
			_plugin.wrap("<div class=\"ui-widget-content pluginsContainer\"></div>");
			_plugin.before("<div class='subPluginTabHandler ui-corner-all ui-widget-header' style='height:auto;padding:3px;'></div>");
			tabAnchors = _plugin.prev();
			for(var index=0; index<pluginPrefs.length;index++)
			{
				var curPlugin = pluginPrefs[index];
				var container = _plugin;
				if(multipleInstance)
				{
					var tabName = curPlugin.subItem[0].text || pluginName;
					tabAnchors.append("<button atServer=\"true\" pluginIndex=\""+index+"\">"+unescape(tabName)+"</button>");
				}
			}
			tabAnchors.find("button").button().click(function(){
				panelPlugins.loadCloneItem($(this));
			});
			tabAnchors.find("button:first").addClass("ui-state-active");
		}
	}
	_plugin.data("totalSubPlugins", pluginPrefs.length);
	context = context || pluginPlaceHolder;
	panelPlugins.itemsChanged(false);
	context.form();
	if(context.find(".panelFormFields").length>0)
	{
		panelPlugins.listenChanges(context.find(".panelFormFields"));
	}
	else
	{
		panelPlugins.listenChanges(context);
	}
	context.unbind("changed").bind("changed", function(){
		panelPlugins.itemsChanged(true);
	});
	$("a#saveContent", context).click(function(){
		var submitScript = "plugin" + plugin + ".saveContent();";
		try{
			eval(submitScript);
		}
		catch(ex){
			if(ex && ex.toString() != "")
			{
				growl("Error", ex, true);
			}
		}
		return false;
	});
	$("a#cancel", context).click(function(){
		if(pluginPlaceHolder.data("hasChanged"))
		{
			jConfirm("Are you sure you want to reject changes made so far?", "Confirm", function(value){
				if(value)
				{
					panelPlugins.itemsChanged(false);
					panelPlugins.loadPlugin(plugin, true);
				}
			});
		}
		else
		{
			panelPlugins.loadPlugin(plugin, true);
		}
		return false;
	});
	$("input", context).keypress(function (e) {
		if ((e.which && e.which == 13) || (e.keyCode && e.keyCode == 13)) {
			$('a#saveContent', context).click();
			return false;
		} else {
			return true;
		}
    });
	vtip(context);
}

panelPlugins.loadCloneItem = function(btn, reloadData)
{
	if(btn.find(".ui-state-active").length>0)return false;
	function continueLoadingClone()
	{
		var plugin = window.currentPlugin;
		var tabAnchors = _plugin.prev();
		var index = btn.attr("pluginIndex");
		var initScript = "plugin" + plugin + ".bindData("+index+");"
		eval("plugin" + plugin + ".subItem = '" + index + "'");
		_plugin.data("subItem", index);
		eval(initScript);
		if(!window.embedPlugin)
		{
			tabAnchors.find(".ui-state-active").removeClass("ui-state-active");
		}
		btn.find("span").addClass("ui-state-active");
		btn.blur();
	}
	if(pluginPlaceHolder.data("hasChanged"))
	{
		jConfirm("If you navigate away, you will loose your unsaved changes. Do you want to continue?", "Confirm", function(value){
			if(value)
			{
				panelPlugins.itemsChanged(false);
				continueLoadingClone();
			}
		});
	}
	else
	{
		continueLoadingClone();
	}
	return false;
}

panelPlugins.addPluginClone = function(cloneName)
{
	var pluginName = window.currentPlugin;
	var _plugin = $("#pnlPlugin" + pluginName);
	var pluginPrefs = common.data.getPluginPrefs(pluginName);
	var subItemIndexToClone = _plugin.data("subItem") || 0;
	if(pluginPrefs && pluginPrefs.length>0)
	{
		var tabCreated = false;
		if(_plugin.parent().find("div.subPluginTabHandler").length == 0)
		{
			_plugin.wrap("<div class=\"ui-widget-content pluginsContainer\"></div>");
			_plugin.before("<div class='subPluginTabHandler ui-corner-all ui-widget-header' style='height:auto;'></div>");
			tabCreated = true;
		}
		var tabAnchors = _plugin.prev();
		function getTabName(pf, ind, trail)
		{
			trail = trail || "";
			var nameToUse = pf + trail;
			nameToUse = unescape(nameToUse.toLowerCase());
			for(var index=0; index<pluginPrefs.length;index++)
			{
				var curPlugin = pluginPrefs[index];
				var container = _plugin;
				var subItem = unescape(curPlugin.subItem[0].text) || "";
				if(nameToUse == subItem.toLowerCase())
				{
					ind = ind || 1;
					ind += 1;
					return getTabName(pf, ind, ind);
				}
			}
			ind = ind || "";
			return pf + ind;
		}
		cloneName = getTabName(cloneName);
		if(tabCreated)
		{
			tabAnchors.append("<button pluginIndex=\""+0+"\">"+pluginName+"</button>");
			panelPlugins.loadCloneItem(tabAnchors.find("button[pluginIndex='"+0+"']").button());
		}
		var tabIndex = pluginPrefs.length;
		tabAnchors.append("<button pluginIndex=\""+tabIndex+"\">"+cloneName+"</button>");
		tabAnchors.find("button[pluginIndex='"+tabIndex+"']").button().attr("disabled", "disabled").addClass("ui-state-disabled");
		var cloneTarget = $.evalJSON($.toJSON(pluginPrefs[subItemIndexToClone]));
		cloneTarget.subItem = [{"text" : cloneName}];
		pluginPrefs.push(cloneTarget);
		panelPlugins.setPluginPrefs(pluginName, pluginPrefs);
		tabAnchors.find("button").click(function(){
			panelPlugins.loadCloneItem($(this));
		});
		tabAnchors.show();
		panelPlugins.saveContent(tabIndex, cloneName, false, "function(flag){if(flag){panelPlugins.loadCloneItem(_plugin.prev().find(\"button[pluginIndex='"+tabIndex+"']\").removeClass('ui-state-disabled').removeAttr('disabled').attr('atServer'), true);panelPlugins.itemsChanged(true);}else{panelPlugins.removePluginClone('"+tabIndex+"');}}");
	}
	_plugin.data("totalSubPlugins", pluginPrefs.length);
}

panelPlugins.removePluginClone = function(subItemIndex, removeAtServer)
{
	var pluginPrefs = common.data.getPluginPrefs(pluginName);
	if(pluginPrefs && pluginPrefs.length>0)
	{
		if(removeAtServer)
		{
			panelPlugins.saveContent(false, false, subItemIndex, "function(flag){if(flag){panelPlugins.removeCloneFromCache("+subItemIndex+", true);}}");
		}
		else
		{
			panelPlugins.removeCloneFromCache(subItemIndex);
		}
	}
	_plugin.data("totalSubPlugins", pluginPrefs.length);
}

panelPlugins.removeCloneFromCache = function(subItemIndex, pluginPrefsRemoved)
{
	var pluginPrefs = common.data.getPluginPrefs(pluginName);
	if(pluginPrefs)
	{
		if(!pluginPrefsRemoved)
		{
			pluginPrefs.remove(subItemIndex);
		}
		var tabAnchors = _plugin.prev();
		tabAnchors.find("button[pluginIndex='"+subItemIndex+"']").remove();
		panelPlugins.setPluginPrefs(pluginName, pluginPrefs);
		panelPlugins.loadCloneItem(tabAnchors.find("button[pluginIndex='0']"));
		if(tabAnchors.find("button").length==1)
		{
			tabAnchors.hide();
		}
		tabAnchors.find("button").each(function(){
			var tabIndex = parseInt($(this).attr("pluginIndex"));
			if(tabIndex && tabIndex>subItemIndex)
			{
				tabIndex -= 1;
				$(this).attr("pluginIndex", tabIndex);
			}
		});
		panelPlugins.itemsChanged(true);
	}
}

panelPlugins.listenChanges = function(context)
{
	context = context || pluginPlaceHolder;
	context.find("input:not(.ignoreChange), select:not(.ignoreChange), textarea:not(.ignoreChange)").change(function(){
		panelPlugins.itemsChanged(true);
	});

	context.find("input[type='text']:not(.ignoreChange), textarea:not(.ignoreChange)").bind("textchange", function(){
		itemsChanged(true);
	});
}

panelPlugins.itemsChanged = function(flag, forEvents, pluginName)
{
	var context = pluginPlaceHolder;
	if(context)
	{
		context.data("hasChanged", flag);
	}
	itemsChanged(flag);
	if(flag && forEvents && window.panelEvents)
	{
		window.panelEvents.updatePluginControlData(pluginName, true);
	}
}

panelPlugins.setPluginPrefs = function(plugin, pluginPrefs)
{
	var prefs = $(document).data("GUIXMLPrefs");
	var plugins = prefs["plugins"];
	var availablePlugins = [];
	if(plugins.length>0)
	{
		var pluginsSubItem = plugins[0]["plugins_subitem"];
		if(pluginsSubItem)
		{
			for(var i=0;i<pluginsSubItem.length;i++)
			{
				var curItem = pluginsSubItem[i];
				var curItemSubItems = curItem["plugins_subitem_subitem"];
				for(var l=0;l<curItemSubItems.length;l++)
				{
					if(curItemSubItems && curItemSubItems[l] && curItemSubItems[l].pluginName)
					{
						var name = getTextValueFromXMLNode(curItemSubItems[l].pluginName, "");
						if(name == plugin)
						{
							curItemSubItems = pluginPrefs;
							l = curItemSubItems.length;
						}
					}
				}
				curItem["plugins_subitem_subitem"] = curItemSubItems;
				pluginsSubItem[i] = curItem;
			}
		}
		plugins[0]["plugins_subitem"] = pluginsSubItem;
	}
	prefs["plugins"] = plugins;
	$(document).data("GUIXMLPrefs", prefs);
}

panelPlugins.saveContent = function(addIndex, cloneName, removeIndex, callback)
{
	if(!window.currentPlugin)return;
	addIndex = addIndex || false;
	removeIndex = removeIndex || false;
	callback = callback || false;
	var submitScript = "plugin" + window.currentPlugin + ".saveContent("+ addIndex + ", '"  + common.methods.htmlEncode(cloneName) + "', " + removeIndex + ", " + callback + ");";
	try{
		eval(submitScript);
	}
	catch(ex){
		if(ex && ex.toString() != "")
		{
			growl("Error", ex, true);
		}
	}
}

panelPlugins.savePluginContentProcess = function(action, formSubItem, pluginIndex, subItemIndex, removeChangeFlag, callback, noGrowl)
{
	common.data.setXMLPrefs("server_settings/plugins/" + pluginIndex +"/" + subItemIndex
		, "vector"
		, action
		, formSubItem
		, function(data){
			data = $.xml2json(data, true);
			common.UI.hideIndicator();
			if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
			{
				common.UI.showIndicator(false, false, "Please wait..");
				common.data.updateLocalPrefs(function(){
					common.UI.hideIndicator();
				});

				if(!noGrowl)
					growl("Data saved", "Your changes are saved", false, 5000);

				if(callback)
				{
					callback(true);
				}
				if(!removeChangeFlag)
				{
					placeHolder.removeData("hasChanged");
					pluginPlaceHolder.removeData("hasChanged");
				}
			}
			else
			{
				growl("Error while saving", "Your changes are not saved", true);
				if(callback)
				{
					callback(false);
				}
			}
	});
}