/*!
* CrushFTP Web GUI interface methods for User Manager
*
* http://crushFTP.com/
*
* Copyright @ CrushFTP
*
* Date: Thu, Aug 11 2011
*
* Author: Vipul Limbachiya
*
* http://vipullimbachiya.com
*/

window.dataBindEvents = [];

var userManager = {
	panelsToLoad : ["Setup", "Settings", "Restrictions", "Admin", "Events", "WebInterface", "Tunnels", "Misc"],
	notAllowedChars : "!@#$%^&*()+=-[]\\\';,./{}|\":<>?~_ ",
	usernamesToIgnorePasswordValidation : ["anonymous", "template", "tempaccount", "default"],
	specialCharactersInUserPass : "!$^&*()_-+=[]{};,.<>?~",
	notAllowedCharsInUserName : "&:/\;<>?+=%#",
	notAllowedCharsInGroupName : ":/\\&#?<>'\"",
	notAllowedCharsInDirName : ":/\\&#?<>",
	ajaxCallURL : "/WebInterface/function/",
	ajaxCallURLBase : "/WebInterface/function/",
	indicatorHTML : "<div class='loadingIndicator'><img src='/WebInterface/Resources/images/process_indicator.gif' alt='loding indicator' /></div>",
	buggyBrowser : $.browser.msie && $.browser.version <= 8,
	defaultUserToLoad : "vipul",
	defaultPanelToShow : false,//"Misc",
	UI :
	{
		addItem : function(listing, newControl, data, callback)
		{
			listing.append(newControl);
			newControl.data("controlData", data);
			newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
			newControl.addClass("ui-widget-header").addClass("ui-selected");
			listing.closest("div.sideScroll").scrollTo(newControl);
			if(callback)
				callback(newControl);
		},
		replaceItem : function(oldControl, newControl, data, callback)
		{
			oldControl.replaceWith(newControl);
			newControl.data("controlData", data);
			newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
			newControl.addClass("ui-widget-header").addClass("ui-selected");
			if(callback)
				callback(newControl);
		},
		removeItem : function(listing, callback, noConfirm)
		{
			var selected = listing.find("li.ui-selected");
			if(selected.length==0)return;
			function continueRemove(flag)
			{
				var toFocus = [];
				if(selected.next("li").length>0)
				{
					toFocus = selected.next("li");
				}
				else if(selected.prev("li").length>0)
				{
					toFocus = selected.prev("li");
				}
				selected.remove();
				if(toFocus.length>0)
				{
					toFocus.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
					toFocus.addClass("ui-widget-header").addClass("ui-selected");
					if(callback)
						callback(toFocus, selected);
				}
				else
				{
					if(callback)
						callback(toFocus, selected);
				}
			}

			if(!noConfirm)
			{
				jConfirm("Are you sure you wish to remove this item?","Confirm", function(flag){
					if(flag)
					{
						continueRemove();
					}
				});
			}
			else
			{
				continueRemove();
			}
		},
		copyItem : function(item, callback)
		{
			if(item.length>0)
			{
				var copy = item.clone(true);
				item.parent().append(copy);
				copy.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
				copy.addClass("ui-widget-header").addClass("ui-selected");
				if(callback)
					callback(copy);
			}
		},
		moveItem : function(item, up, autoScroll, callback)
		{
			if(item.length>0)
			{
				if(up)
				{
					if(item.prev().length>0)
						item.prev().before(item);
				}
				else
				{
					if(item.next().length>0)
						item.next().after(item);
				}
				if(autoScroll)
					item.closest("div.sideScroll").scrollTo(item);
				if(callback)
					callback(item);
			}
		},
		multiOptionControlDataBind : function(dataSet, dataColumn, control, bindItemMethod, setInheritedPropery, postBindMethod, noSubitem){
			var dataItem = dataSet[dataColumn];
			if(dataItem)
			{
				var dataInheritedFrom = dataItem["inheritedFrom"];
				if(typeof dataItem == "string")
				{
					var curData = userManager.methods.seperateValueAndInheritValue(userManager.data.getValueFromJson(dataSet, dataColumn));
					var curVal = curData.value;
					dataInheritedFrom = curData.inherit || dataInheritedFrom || "default";
				}
				if(dataInheritedFrom)
				{
					var parent = $(control).closest("fieldset").attr("inheritedFrom", dataInheritedFrom);
					if(!dataInheritedFrom)
					{
						parent.removeAttr("inheritedFrom");
					}
					if(!parent.hasClass("inheritValSet"))
					{
						parent.addClass("inheritValSet").find("legend").text(dataInheritedFrom);
					}
				}
				if(!noSubitem)
				{
					dataItem = dataItem[dataColumn + "_subitem"];
				}
				if(dataItem)
				{
					control.empty();
					if(postBindMethod)
					{
						postBindMethod();
					}
					function addNewOption(curItem)
					{
						var newControl = bindItemMethod(curItem);
						if(!newControl)return;
						control.append(newControl);
						newControl.data("controlData", curItem);
					}
					if(dataItem.length && dataItem.length>0 && !noSubitem)
					{
						for(var i=0; i < dataItem.length; i++)
						{
							addNewOption(dataItem[i]);
						}
					}
					else
					{
						addNewOption(dataItem);
					}
				}
			}
			else
			{
				dataInheritedFrom = "default";
				var parent = $(control).closest("fieldset").attr("inheritedFrom", dataInheritedFrom);
				if(!dataInheritedFrom)
				{
					parent.removeAttr("inheritedFrom");
				}
				if(!parent.hasClass("inheritValSet"))
				{
					parent.addClass("inheritValSet").find("legend").text(dataInheritedFrom);
				}
			}
			if(setInheritedPropery)
			{
				userManager.data.setInheritPropertyOfSection(control, dataColumn, true);
			}
		},
		showIndicator : function(loaderOnly, blockElement, message)
		{
			if(loaderOnly)
			{
				blockElement = blockElement || $("#panels");
				if(blockElement.length>0)
				{
					blockElement.find("div.loadingIndicator").remove();
					blockElement.prepend(userManager.indicatorHTML);
				}
			}
			else
			{
				userManager.placeHolder = $("#placeHolder");
				blockElement = blockElement || userManager.placeHolder;
				message = message || "Loading...";
				blockElement.block({
					message:  '<div><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-refresh"></span>'+message+'</div>',
					css: {
						border: 'none',
						padding: '15px',
						backgroundColor: '#000',
						'-webkit-border-radius': '10px',
						'-moz-border-radius': '10px',
						opacity: .5,
						color: '#fff',
						width: '100px',
						'text-align':'left'
					}
				});
			}
		},
		hideIndicator : function(loaderOnly, blockElement)
		{
			if(loaderOnly)
			{
				blockElement = blockElement || $("#panels");
				if(blockElement.length>0)
				{
					blockElement.find("div.loadingIndicator").remove();
				}
			}
			else
			{
				blockElement = blockElement || userManager.placeHolder;
				blockElement.unblock();
			}
		},
		initLoadingIndicator : function()
		{
			$("#loadingIndicator").dialog({
				autoOpen: false,
				dialogClass: "loadingIndicatorWindow",
				closeOnEscape: false,
				draggable: false,
				width: 150,
				minHeight: 50,
				modal: true,
				buttons: {},
				resizable: false,
				open: function() {
					$('body').css('overflow','hidden');
				},
				close: function() {
					$('body').css('overflow','auto');
				}
			});
		},
		showLoadingIndicator : function(data)
		{
			if(!data)return;
			$("#loadingIndicator").html(data.message && '' != data.message ? data.message : 'Please wait...');
			$("#loadingIndicator").dialog('option', 'title', data.title && '' != data.title ? data.title : 'Loading');
			$("#loadingIndicator").dialog('open');
		},
		hideLoadingIndicator : function()
		{
			$("#loadingIndicator").dialog('close');
		},
		checkUnchekInput : function(input, flag)
		{
			if(flag)
			{
				if(input.attr("type") == "radio")
				{
					var selected = input.closest(".customForm").find("input[name='"+input.attr("name")+"']:checked");
					if(input == selected)return;
					input.closest(".customForm").find("input[name='"+input.attr("name")+"']").each(function(){
						var _parent = $(this).parent().next();
						$(_parent).removeClass("ui-state-active").removeClass("ui-icon-radio-off").removeClass("ui-icon ui-icon-circle-check").addClass("ui-icon-radio-off");
						$(_parent).find("span").removeClass("ui-state-active").removeClass("ui-icon-radio-off").removeClass("ui-icon ui-icon-circle-check").addClass("ui-icon-radio-off");
					});

					input.attr("checked","checked").parent("label").next().find("span").removeClass("ui-icon-radio-off").addClass("ui-icon ui-icon-circle-check");
				}
				else if(input.attr("type") == "checkbox")
				{
					input.attr("checked","checked").parent("label").next().find("span").addClass("ui-icon ui-icon-check");
				}
			}
			else
			{
				if(input.attr("type") == "radio")
				{
					var selected = input.closest(".customForm").find("input[name='"+input.attr("name")+"']:checked");
					if(input == selected)return;
					input.removeAttr("checked").parent("label").next().find("span").addClass("ui-icon-radio-off").removeClass("ui-icon ui-icon-circle-check");
				}
				else if(input.attr("type") == "checkbox")
				{
					input.removeAttr("checked").parent("label").next().find("span").removeClass("ui-icon").removeClass("ui-icon-check");
				}
			}
			return input;
		},
		isScrolledIntoView : function(elem) {
			if(!elem ||  elem.length ==0) return;
			var docViewTop = $(window).scrollTop();
			var docViewBottom = docViewTop + $(window).height();

			var elemTop = $(elem).offset().top;
			var elemBottom = elemTop + $(elem).height();

			return ((elemBottom >= docViewTop) && (elemTop <= docViewBottom));
		},
		togglePanels : function(panel) {
			if(!panel)return;
			$('.checkboxArea>:checkbox', panel).each(function () {
				$(this).unbind("change").change(function () {
					if($(this).closest("td").hasClass("noInherit"))
					{
						userManager.UI.checkUnchekInput($(this),true);
						return;
					}
					userManager.UI.disableUncheckedPanel($(this));
				}).trigger("change");
			});
		},
		disableUncheckedPanel : function(checkbox, inheritedFrom) {
			if(!checkbox)return;
			inheritedFrom = inheritedFrom || "default";
			if(checkbox.closest("fieldset").attr("inheritedFrom"))inheritedFrom=checkbox.closest("fieldset").attr("inheritedFrom");
			inheritedFrom = inheritedFrom || "default";
			if (checkbox.is(':checked')) {
				checkbox.closest("tr").find("td.settingsArea>div:first").unblock();
				checkbox.closest("fieldset").find("legend").remove();
			} else {
				checkbox.closest("tr").find("td.settingsArea>div:first").block({ message: null, overlayCSS: { opacity: 0.1, cursor: 'normal'} });
				if(checkbox.closest("fieldset").find("legend").length==0)
				{
					checkbox.closest("fieldset").addClass('noForm').prepend("<legend>"+inheritedFrom+"</legend>");
				}
				else
				{
					checkbox.closest("fieldset").find("legend").text(inheritedFrom);
				}
				checkbox.closest("fieldset").find(".validationErrorMessage").remove();
				checkbox.closest("fieldset").find("input.ui-state-error").removeClass("ui-state-error nobg");
			}
		},
		panelsPostbindEvent : function(panel, inherit)
		{
			var hiddenSections = [];
			if(!inherit)
			{
				$(".inheritSet", panel).each(function(){
					if($(this).attr("inheritedfrom"))
					{
						if($(this).attr("inheritedfrom").toLowerCase() == 'default')
							hiddenSections.push($(this).hide());
					}
					else
					{
						hiddenSections.push($(this).hide());
					}
				});

				if(panel.find("fieldset:visible").length == 0)
				{
					$(".collapseHandle", panel.closest("fieldset")).click();
				}
				if(userManager.isUserLimitedAdmin)
					$(".adminOnly", panel).remove();
			}
			userManager.UI.updateHiddenSectionsCountForPanel(panel, hiddenSections.length);
			userManager.methods.listenChanges(panel);
		},
		updateHiddenSectionsCount : function(){
			var hiddenSections = $(".inheritSet:hidden", userManager.GUIInterface).length;
			if(hiddenSections==0)
			{
				$("#hiddenPanelsNote", userManager.GUIInterface).hide();
				$("span.hiddenSectionCount", userManager.GUIInterface).hide();
			}
			else
			{
				$("#hiddenPanelsCount", $("#hiddenPanelsNote", userManager.GUIInterface).show()).html("<strong>" + hiddenSections + "</strong>");
			}
		},
		updateHiddenSectionsCountForPanel : function(panel, hiddenSections){
			var collapseHandle = $("legend.collapseHandle:first", panel);
			if(hiddenSections == 0)
			{
				$("span.hiddenSectionCount", panel).hide();
			}
			else
			{
				if($("span.hiddenSectionCount", panel).length == 0)
				{
					collapseHandle.after("<span class='hiddenSectionCount notes ienote'></span>");
				}
				var sectionNote = hiddenSections <=1 ? "section is" : "sections are";
				$("span.hiddenSectionCount", panel).html((" (Total <strong>" + hiddenSections + "</strong> "+sectionNote+" not being shown)")).show();
			}
		},
		initEvents : function()
		{
			if($("ul#context-menu").length==0)
			{
				var contextmenu = $('#topNavigation').clone();
				contextmenu.attr("id", "context-menu").find("li").show();
				$("body").append(contextmenu);
			}

			contextMenu.handler=$("#userList");    // element which triggers right click context menu
			contextMenu.init();

			$("#quickJump", "#GUIInterface").hide();
			$("#userSpecificButtons", "#GUIInterface").hide();
			$('#quick_jump', "#GUIInterface").unbind("change").change(function (evt, voidAnimation) {
				var id = $('#quick_jump').val();
				var pnl = $('#pnl' + id);
				if(id && id.length>0 && pnl.length>0)
				{
					if(!voidAnimation)
					{
						if(userManager.placeHolder)
						{
							$(userManager.placeHolder).find("div.userMgrPanel").show();
						}
						var top_val = pnl.offset().top;
						$('html, body').animate({ scrollTop: top_val - 100 }, 200);
						pnl.find("fieldset:first").effect("highlight", {}, 2000);
						$('#quick_filter').val("");
					}
					$('#quick_jump').val("");
					if(pnl.find("div.dataDiv:hidden").length>0)
					{
						pnl.find("legend.collapseHandle").trigger("click");
					}
					pnl.find(".inheritSet:hidden").show();
					userManager.UI.updateHiddenSectionsCountForPanel(pnl, 0);
					userManager.UI.updateHiddenSectionsCount();
				}
			});

			$(window).resize(function () {
				userManager.UI.resizeSidebar();
			});
			userManager.UI.resizeSidebar();

			$(".backToTop", "#GUIInterface").unbind().click(function () {
				$('html,body').animate({
					scrollTop: 0
				}, 500, false);
				return false;
			});

			$("#showAllPanels", "#GUIInterface").unbind().click(function(e, showFlag){
				e.stopPropagation();
				e.preventDefault();
				var showHideBtn = $(this);
				var showItems = true;
				if(!showFlag)
				{
					$('#quick_filter').val("");
					window.last_searched_quick_filter = "";
					$(userManager.placeHolder).find("div.userMgrPanel").show();
					if(showHideBtn.attr("state") == "hidden")
					{
						showItems = false;
						showHideBtn.attr("state", "visible");
						showHideBtn.find("span.showHideText").text("Show all");
					}
					else
					{
						showHideBtn.attr("state", "hidden");
						showHideBtn.find("span.showHideText").text("Hide Defaults");
					}
				}
				$(".collapseHandle").each(function(){
					var parentFs = $(this).parent();
					if(showFlag)
					{
						parentFs.find(".inheritSet").show();
					}
					else
					{
						if(showItems)
						{
							parentFs.find(".inheritSet").show();
						}
						else
						{
							parentFs.find(".inheritSet").hide();
						}
					}
					if(parentFs.find("div.dataDiv:hidden").length>0)
					{
						$(this).trigger("click");
					}
					userManager.UI.updateHiddenSectionsCountForPanel(parentFs, $(".inheritSet:hidden", parentFs).length);
				});
				setTimeout(function(){
					userManager.UI.updateHiddenSectionsCount();
				}, 100);

				return false;
			});
			var userList = $("#userList");
			$("#filterUserInList", "#GUIInterface").unbind("keyup").keyup(function (evt) {
				var evt = (evt) ? evt : ((event) ? event : null);
				var phrase = this.value;
				if (window.last_searched_user_name && window.last_searched_user_name === phrase) {
					return false;
				}
				userManager.methods.buildUserList(false, phrase);
				window.last_searched_user_name = phrase;
			});

			$("#filterUserByInheritance", "#GUIInterface").unbind("keyup").keyup(function (evt) {
				var evt = (evt) ? evt : ((event) ? event : null);
				var phrase = this.value;
				if (window.last_searched_inheritance_name && window.last_searched_inheritance_name === phrase) {
					return false;
				}
				userManager.methods.buildUserList(false, false, false, phrase);
				window.last_searched_inheritance_name = phrase;
			});

			$("#quick_filter", "#GUIInterface").unbind("keyup").keyup(function (evt) {
				var evt = (evt) ? evt : ((event) ? event : null);
				var phrase = this.value;
				function startFilter()
				{
					if (window.last_searched_quick_filter && window.last_searched_quick_filter === phrase) {
						return false;
					}
					var captured = false;
					$("#showAllPanels").trigger("click", [true]);
					if(!phrase || (phrase && phrase.length==0))
					{
						$(userManager.placeHolder).find(".userMgrPanel").find(".dataDiv").find("fieldset").show();
						var showHideBtn = $("#showAllPanels", "#GUIInterface");
						if(showHideBtn.attr("state") == "hidden")
						{
							showHideBtn.attr("state", "visible");
						}
						else
						{
							showHideBtn.attr("state", "hidden");
						}
						showHideBtn.trigger("click");
						$(userManager.placeHolder).find(".userMgrPanel").find(".dataDiv").find("fieldset[inheritedfrom!='default']").each(function(){
							if($(this).attr("inheritedfrom"))
							{
								$(this).show();
							}
						});
						return;
					}
					var userMgrPanel = $(userManager.placeHolder).find("div.userMgrPanel").hide().each(function(){
						var matching = $(this).find("fieldset[filterKeywords*='"+phrase+"']");
						if(matching && matching.length>0)
						{
							var panel = $(this).attr("id");
							if(panel)
							{
								panel = panel.replace("pnl", "");
								$("#quick_jump").val(panel).trigger("change", [true]);
								setTimeout(function(){
									if(!captured)
									{
										var top_val = matching.offset().top;
										$('html, body').animate({ scrollTop: top_val - 100}, 200);
										matching.effect("highlight", {}, 2000);
									}
									matching.closest(".userMgrPanel").find(".dataDiv").find("fieldset").hide();
									matching.show();
								}, 0);
								captured = true;
							}
							$(this).show();
						}
					});
					window.last_searched_quick_filter = phrase;
				}
				if (evt.keyCode == 13) {
					startFilter();
				} else {
					delay(function () {
						startFilter();
					}, 500);
				}
			});

			$("#groupSelectList", "#GUIInterface").unbind("change").bind("change", function(){
				if($(this).val() == "#addnewgroup#")
				{
					$(this).val(userManager.lastSelectedGroup);
					$("a.addNewGroup", "#GUIInterface").trigger("click");
					return false;
				}
				else
				{
					userManager.lastSelectedGroup = $(this).val();
					userManager.methods.buildUserList(false, false, $(this).val());
				}
			});

			$("#userConnectionGroups", "#GUIInterface").unbind("change").bind("change", function(){
				userManager.data.storeCurrentUserInfo();
				$(".reloadUsersLink", "#sideBar").trigger("click");
			});

			$("#groupListToSelectForInheritance", "#GUIInterface").unbind("change").bind("change", function(){
				if($(this).val() != "")
					userManager.methods.pickupUserFromGroup($(this).val());
				$(this).val("");
			});

			//Add, copy and edit user events
			$("#addUser, a.createNewUser", "#GUIInterface").unbind("click").bind("click", function(){
				function addUserMethod(uName)
				{
					uName = uName || "";
					jPrompt("Enter a User Name :", uName, "User Name", function(value){
						if(value)
						{
							value = $.trim(value);
							var userName = value;
							var waitBoxOpen = false;

							function continueUserCreation(value)
							{
								jAlert("Checking user name availability. Please wait..", "Wait", function(){
									waitBoxOpen = false;
								}, {
									okButtonText : "Cancel"
								});
								waitBoxOpen = true;
								userManager.methods.checkUserNameAvailability(value, function(available){
									if(available)
									{
										jAlert("User already exist, please choose another name", "Message", function(){
											addUserMethod(value);
										});
									}
									else
									{
										if(waitBoxOpen)
										{
											$("#popup_container").find(".submitActionOk").trigger("click");
											function choosePassword(pswd)
											{
												jPrompt("Choose a password for this user:", pswd || "", "Password", function(password){
													if(password != null)
													{
														var msgs = userManager.methods.validateUserPassword(password, userName.toLowerCase());
														if(msgs && msgs.length)
														{
															jAlert(msgs[0], "Error", function(){
																choosePassword(password);
															}, {
																classForPopupPanel : 'warning'
															});
															return false;
														}
														userManager.UI.showLoadingIndicator(true);
														userManager.dataRepo.saveUserInfo("<?xml version=\"1.0\" encoding=\"UTF-8\"?><user type=\"properties\"><username>"+userManager.methods.htmlEncode(userName)+"</username><password>"+userManager.methods.htmlEncode(password)+"</password><max_logins>0</max_logins><root_dir>/</root_dir></user>", "<?xml version=\"1.0\" encoding=\"UTF-8\"?><vfs type=\"properties\"></vfs>", "<?xml version=\"1.0\" encoding=\"UTF-8\"?><permissions type=\"properties\"><item name=\"/\">(read)(view)(resume)</item></permissions>", userName, "new", function(response){
															userManager.UI.hideLoadingIndicator();
															if(response)
															{
																userManager.UI.growl("Message : ", "User created", false, 3000);
																$(".reloadUsersLink", "#GUIInterface").trigger("click", [{callback : function(){
																	var selectedGroup = $("#groupSelectList").find("option:selected");
																	if(selectedGroup.attr("rel")	== "editable")
																	{
																		userManager.data.addUsersToGroup(selectedGroup.val(), [userName], function(){
																			userList.find("li").removeClass("ui-selected ui-state-active ui-state-focus");
																			userList.find("li[userName='"+userName+"']").trigger("dblclick");
																		});
																	}
																	else
																	{
																		userList.find("li").removeClass("ui-selected ui-state-active ui-state-focus");
																		userList.find("li[userName='"+userName+"']").trigger("dblclick");
																	}
																}}]);
															}
															else
															{
																userManager.UI.growl("Failure : ", data, true, true);
															}
														});
													}
												}, false, false, {
													passwordInput : true
												});
											}
											userManager.methods.showInfoToUserAboutSpecialUser(userName, choosePassword);
										}
									}
								});
							}

							if(userManager.methods.hasSpecialCharacters(value, userManager.notAllowedCharsInUserName))
							{
								jAlert("You can not use these characters in user name : \"" + userManager.notAllowedCharsInUserName + "\"", "Error", function(){
									addUserMethod(value);
								});
							}
							else
							{
								continueUserCreation(value);
							}
						}
					});
				}
				addUserMethod();
				return false;
			});

			//Copy selected user
			$("#copyUser, a.duplicateSelectedUser", "#GUIInterface").unbind("click").bind("click", function(){
				var selectedUser = userList.find("li.userSelected");
				var contextMenu = $(this).closest("ul#context-menu");
				if(contextMenu.length>0)
				{
					var curElem = contextMenu.data("selectedUser");
					if(curElem && curElem.length)
					{
						selectedUser = curElem;
					}
				}
				if(selectedUser.length>0)
				{
					var selectedUserName = selectedUser.attr("username");
					function copyUser(val)
					{
						selectedUserName = val || "Copy of " + selectedUserName;
						jPrompt("Enter a User Name :", selectedUserName, "Enter User Name", function(value){
							if(value)
							{
								function continueSaving()
								{
									userManager.UI.showLoadingIndicator(true);
									userManager.data.serverRequest({
										command: 'getUser',
										serverGroup : $("#userConnectionGroups").val() || "MainUsers",
										username : selectedUser.attr("username")
									},
									function(data){
										if(data)
										{
											var usersData = $.xml2json(data, false);
											if(usersData && usersData["response_status"] && usersData["response_status"] == "OK")
											{
												$(data).find("username, user_name").text(value);
												var privs = getTextFromXML($(data).find("permissions[type='properties']")[0]);
												privs = privs.replace("<permissions","<VFS");
												privs = privs.replace("permissions>","VFS>");

												var userItems = usersData.response_data.user_items;
												var vfs = panelSetup.generateVFSXML(userItems);
												if(!vfs)
												{
													vfs = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><vfs type=\"properties\"></vfs>";
												}

												userManager.dataRepo.saveUserInfo("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n"+ getTextFromXML($(data).find("user")[0]), vfs,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n" + privs, value, "new", function(response){
													if(response)
													{
														userManager.UI.growl("Message : ", "User created", false, 3000);
														userManager.data.copyUsersGroupInfo(selectedUserName, value, function(flag){
															if(flag)
															{
																userManager.data.copyUsersInheritanceInfo(selectedUserName, value, function(flag){
																	userManager.UI.hideLoadingIndicator();
																	if(flag)
																	{
																		$(".reloadUsersLink", "#GUIInterface").trigger("click", [{callback : function(){
																			userList.find("li").removeClass("ui-selected ui-state-active ui-state-focus");
																			userList.find("li[userName='"+value+"']").trigger("dblclick");
																		}}]);
																	}
																});
															}
															else
															{
																userManager.UI.hideLoadingIndicator();
															}
														});
													}
													else
													{
														userManager.UI.growl("Failure : ", data, true, true);
													}
												});
											}
										}
									});
								}
								var waitBoxOpen = false;
								jAlert("Checking user name availability. Please wait..", "Wait", function(){
									waitBoxOpen = false;
								}, {
									okButtonText : "Cancel"
								});
								waitBoxOpen = true;
								userManager.methods.checkUserNameAvailability(value, function(available){
									if(available)
									{
										jAlert("User already exist, please choose another name", "Message", function(){
											copyUser(value);
										});
									}
									else
									{
										if(waitBoxOpen)
										{
											$("#popup_container").find(".submitActionOk").trigger("click");
											userManager.methods.showInfoToUserAboutSpecialUser(value, continueSaving);
										}
									}
								});
							}
						});
					}
					copyUser();
				}
				else
				{
					userManager.UI.growl("Message : ", "Please select user to copy", false, 3000);
				}
				return false;
			});

			//Delete selected user
			$("#deleteUser, a.deleteSelectedUsers", "#GUIInterface").unbind("click").bind("click", function(){
				var hasTempAccountUser = false;
				var hasCurrentLoggedUser = false;
				var selectedUsers = $("#userList").find("li.ui-selected");
				var contextMenu = $(this).closest("ul#context-menu");
				var curtentUserName = userManager.storage("username");
				if(contextMenu.length>0)
				{
					var curElem = contextMenu.data("selectedUser");
					if(curElem && curElem.length)
					{
						selectedUsers.push(curElem);
					}
				}
				if(selectedUsers.length>0)
				{
					var selectedUserNames = [];
					selectedUsers.each(function(){
						var userName = $(this).attr("username");
						if(userName)
						{
							if(userName.toLowerCase() == "tempaccount")
							{
								hasTempAccountUser = true;
							}
							if(userName.toLowerCase() == curtentUserName.toLowerCase())
							{
								hasCurrentLoggedUser = true;
							}
							if(!selectedUserNames.has(userName))
								selectedUserNames.push(userName);
						}
					});

					function continueMultiDelete()
					{
						jConfirm("Are you sure you wish to delete  \n\n" + selectedUserNames.join("\n") + " \n\n users ?", "Confirm",  function(value){
							if(value)
							{
								userManager.dataRepo.saveUserInfo("<?xml version=\"1.0\" encoding=\"UTF-8\"?>", "<?xml version=\"1.0\" encoding=\"UTF-8\"?><vfs type=\"properties\"></vfs>", "<?xml version=\"1.0\" encoding=\"UTF-8\"?><permissions type=\"properties\"></permissions>", selectedUserNames.join(";"), "delete", function(data){
									if(data)
									{
										var usersData = $.xml2json(data, false);
										if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
										{
											userManager.UI.growl("Message : ", "User \"" + selectedUserNames.join("; ") + "\" deleted", false, 3000);
											$(".reloadUsersLink", "#GUIInterface").trigger("click");
										}
										else
										{
											userManager.UI.growl("Failure : ", "Error occured while deleting user \"" + selectedUserNames.join("; ") + "\" \r\n" + data , false, 3000);
										}
									}
									else
									{
										userManager.UI.growl("Failure : ", data, true, true);
									}
								});
							}
						});
					}

					if(hasCurrentLoggedUser)
					{
						jAlert("You can not delete the user you are currently logged in with : \"" + curtentUserName + "\"", "Error", false, {
							classForPopupPanel : 'warning'
						});
					}
					else if(hasTempAccountUser)
					{
						jConfirm("Deleting the \"TempAccount\" user will disable the WebInterface \"Sharing\" functionality. <br>This user is used as a template for that feature.<br>This user can not be logged in as, and is safe to leave here.", "Confirm",  function(value){
							if(value)
							{
								continueMultiDelete();
							}
						});
					}
					else
					{
						continueMultiDelete();
					}
				}
				else
				{
					userManager.UI.growl("Message : ", "Please select user to delete", false, 3000);
				}
				return false;
			});

			//Reload users list
			$(".reloadUsersLink", "#GUIInterface").unbind("click").bind("click", function(evt, data){
				var userList = $("#userList", "#GUIInterface");
				var userName = userManager.storage("userName");
				userManager.UI.showIndicator(false, userList, "Wait..");
				userManager.methods.prepareDataRepo(function(){
					userManager.methods.refreshUsersFromServer(function(){
						var selectedGroup = false;
						var grpName = $("#groupSelectList").val();
						if(data && data.callback)
						{
							selectedGroup = $("#groupSelectList").val();
							if(!selectedGroup || selectedGroup.length == 0) selectedGroup = "all";
						}
						userManager.methods.buildUserList(false, false, selectedGroup);
						userManager.data.bindGroupDetails(false, false, selectedGroup, function(){
							if(!selectedGroup)
							{
								$("#groupSelectList").val(grpName).trigger("change");
							}
						});
						userManager.UI.initEvents();
						userManager.data.bindInheritanceDetails();
						if(userName)
						{
							userList.find("li[userName='"+userName+"']").click();
							$("#quickJump", "#GUIInterface").show();
							$("#userSpecificButtons", "#GUIInterface").show();
						}
						userManager.UI.hideIndicator(false, userList);
						if(data && data.callback)
						{
							data.callback();
						}
					});
				}, true);
				return false;
			});

			var sideBar = $("#sideBar", "#GUIInterface");
			$(".selectAllUsers, .deSelectUsers", sideBar).unbind().click(function(){
				if($(this).is(".selectAllUsers"))
				{
					userList.find("li").addClass("ui-selected ui-state-active");
				}
				else
				{
					userList.find("li").removeClass("ui-selected ui-state-active ui-state-focus");
				}
				return false;
			});

			// Methods for group menu in top bar
			$("a.addNewGroup", "#GUIInterface").unbind("click").bind("click", function(){
				var selectedUsers = userList.find("li.ui-selected");
				var users = [];
				selectedUsers.each(function(){
					users.push($(this).attr("username"));
				});
				var strMsg = "Total " + selectedUsers.length + " user(s) selected : \"" + users.join(", ") + "\"";
				function addGroup(groupName)
				{
					groupName = groupName || "";
					jPrompt("Enter Group Name :", groupName, "Group Name", function(value){
						if(value != null)
						{
							groupName = $.trim(value);
							if(value.length == 0)
							{
								jAlert("Group name is required", "Error", function(){
									addGroup();
								});
							}
							else if(userManager.methods.hasSpecialCharacters(groupName, userManager.notAllowedCharsInGroupName))
							{
								jAlert("You can not use these characters in name : \"" + userManager.notAllowedCharsInGroupName + "\"", "Error", function(){
									addGroup(groupName);
								});
							}
							else
							{
								var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
								userManager.UI.showLoadingIndicator(true);
								userManager.dataRepo.getGroupInfo("group", serverGroup, function(info, xml){
									if(info)
									{
										userManager.storage("groupInfo", info);
										userManager.storage("groupInfoXML", xml);

										if(userManager.methods.checkGroupNameExistance(groupName))
										{
											userManager.UI.hideLoadingIndicator();
											jAlert("Group name already exist, choose another name", "Error", function(){
												addGroup(groupName);
											});
										}
										else
										{
											var groupInfoXML = $(userManager.storage("groupInfoXML"));
											//Method to save group
											var xml = [];
											xml.push("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
											xml.push("<groups type=\"properties\">");

											if(groupInfoXML && groupInfoXML.length>0)
											{
												groupInfoXML.find("result_item result_item").each(function(){
													var groupAndUsers = $(this).find("*[type='vector']").each(function(){
														var groupName = $(this).attr("name") || $(this).get(0).tagName;
														xml.push("<item name=\""+groupName+"\" type=\"vector\">");
														$(this).children().each(function(){
															xml.push("<item_subitem>"+$(this).text()+"</item_subitem>");
														});
														xml.push("</item>");
													});
												});
											}

											xml.push("<item name=\""+groupName+"\" type=\"vector\">");
											if(users.length>0)
											{
												for(var i=0; i<users.length;i++)
												{
													var userName = users[i];
													if(userName && userName.length>0)
													{
														xml.push("<item_subitem>"+userName+"</item_subitem>");
													}
												}
											}
											else
											{
												xml.push("<item_subitem></item_subitem>");
											}

											xml.push("</item>");
											xml.push("</groups>");
											userManager.dataRepo.saveGroupInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
												if(data)
												{
													userManager.data.bindGroupDetails(true, false, groupName);
													userManager.UI.growl("Message : ", "New group \""+ groupName +"\" added (with total "+ selectedUsers.length +" users)", false, 3000);
													userManager.UI.hideLoadingIndicator();
												}
												else
												{
													userManager.UI.growl("Failure : ", data, true, true);
												}
											});
										}
									}
								});
							}
						}
					}, false
					, false
					,{
						messageToAppend : users.length>0 ? strMsg + "<br /><br />" : ""
					});
				}
				addGroup();
				return false;
			});

			$("a.renameCurrentGroup", "#GUIInterface").unbind("click").bind("click", function(){
				var groupSelectList = $("#groupSelectList", "#GUIInterface");
				var selectedGroup = groupSelectList.find("option:selected");
				if(selectedGroup.length>0)
				{
					if(selectedGroup.attr("rel")=="editable")
					{
						var groupNameOld = $.trim(selectedGroup.val());
						function renameGroup(valToShow)
						{
							valToShow = valToShow || groupNameOld;
							jPrompt("Enter Group Name :", groupNameOld, "Group Name", function(value){
								if(value)
								{
									//Method to rename group
									var groupNameNew = $.trim(value);
									if($.trim(groupNameOld) == $.trim(groupNameNew))
									{
										return false;
									}
									else if(groupNameNew.length == 0)
									{
										jAlert("Group name is required", "Error", function(){
											renameGroup();
										});
									}
									else if(userManager.methods.hasSpecialCharacters(groupNameNew, userManager.notAllowedCharsInGroupName))
									{
										jAlert("You can not use these characters in group name : \"" + userManager.notAllowedCharsInGroupName + "\"", "Error", function(){
											renameGroup(groupNameNew);
										});
									}
									else
									{
										var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
										userManager.UI.showLoadingIndicator(true);
										userManager.dataRepo.getGroupInfo("group", serverGroup, function(info, xml){
											if(info)
											{
												userManager.storage("groupInfo", info);
												userManager.storage("groupInfoXML", xml);

												if(userManager.methods.checkGroupNameExistance(groupNameNew) && $.trim(groupNameOld).toLowerCase() != $.trim(groupNameNew).toLowerCase())
												{
													userManager.UI.hideLoadingIndicator();
													jAlert("Group name already exist, choose another name", "Error", function(){
														renameGroup(groupNameNew);
													});
												}
												else
												{
													var groupInfoXML = $(userManager.storage("groupInfoXML"));
													//Method to save group
													var xml = [];
													xml.push("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
													xml.push("<groups type=\"properties\">");

													if(groupInfoXML && groupInfoXML.length>0)
													{
														groupInfoXML.find("result_item result_item").each(function(){
															var groupAndUsers = $(this).find("*[type='vector']").each(function(){
																var groupName = $(this).attr("name") || $(this).get(0).tagName;
																if($.trim(groupName).toLowerCase()== $.trim(groupNameOld).toLowerCase())
																{
																	groupName = groupNameNew;
																}
																xml.push("<item name=\""+groupName+"\" type=\"vector\">");
																$(this).children().each(function(){
																	xml.push("<item_subitem>"+$(this).text()+"</item_subitem>");
																});
																xml.push("</item>");
															});
														});
													}
													xml.push("</groups>");
													userManager.dataRepo.saveGroupInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
														if(data)
														{
															userManager.data.bindGroupDetails(true, false, groupNameNew);
															userManager.UI.growl("Message : ", "Group \""+ groupNameOld +"\" renamed to \"" + groupNameNew + "\"", false, 3000);
															userManager.UI.hideLoadingIndicator();
														}
														else
														{
															userManager.UI.growl("Failure : ", data, true, true);
														}
													});
												}
											}
										});
									}
								}
							});
						}
						renameGroup();
					}
					else
					{
						jAlert("This group can not be modified", "Message");
					}
				}
				else
				{
					jAlert("You must select a group to rename", "Message");
				}
				return false;
			});

			$("a.deleteSelectedGroup", "#GUIInterface").unbind("click").bind("click", function(){
				var groupSelectList = $("#groupSelectList", "#GUIInterface");
				var selectedGroup = groupSelectList.find("option:selected");
				if(selectedGroup.length>0)
				{
					if(selectedGroup.attr("rel")=="editable")
					{
						var groupNameToDelete = selectedGroup.val();
						jConfirm("Are you sure you wish to delete group : '" + groupNameToDelete + "' ? <br /> <br/> (Users will not be deleted, just the group reference)", "Confirm", function(value){
							if(value)
							{
								//Method to remove group
								var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
								userManager.UI.showLoadingIndicator(true);
								userManager.dataRepo.getGroupInfo("group", serverGroup, function(info, xml){
									if(info)
									{
										userManager.storage("groupInfo", info);
										userManager.storage("groupInfoXML", xml);

										var groupInfoXML = $(userManager.storage("groupInfoXML"));
										//Method to save group
										var xml = [];
										xml.push("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
										xml.push("<groups type=\"properties\">");

										if(groupInfoXML && groupInfoXML.length>0)
										{
											groupInfoXML.find("result_item result_item").each(function(){
												var groupAndUsers = $(this).find("*[type='vector']").each(function(){
													var groupName = $(this).attr("name") || $(this).get(0).tagName;
													if($.trim(groupName).toLowerCase()!= $.trim(groupNameToDelete).toLowerCase())
													{
														xml.push("<item name=\""+groupName+"\" type=\"vector\">");
														$(this).children().each(function(){
															xml.push("<item_subitem>"+$(this).text()+"</item_subitem>");
														});
														xml.push("</item>");
													}
												});
											});
										}
										xml.push("</groups>");
										userManager.dataRepo.saveGroupInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
											if(data)
											{
												userManager.data.bindGroupDetails(true, true);
												userManager.UI.growl("Message : ", "Group \""+ groupNameToDelete +"\" deleted", false, 3000);
												userManager.UI.hideLoadingIndicator();
											}
											else
											{
												userManager.UI.growl("Failure : ", data, true, true);
											}
										});
									}
								});
							}
						});
					}
					else
					{
						jAlert("This group can not be deleted", "Message");
					}
				}
				else
				{
					jAlert("You must select a group to delete", "Message");
				}
				return false;
			});

			$("a.addSelectedUsersToGroup", "#GUIInterface").unbind("click").bind("click", function(){
				var selectedUsers = userList.find("li.ui-selected");
				var contextMenu = $(this).closest("ul#context-menu");
				if(contextMenu.length>0)
				{
					var curElem = contextMenu.data("selectedUser");
					if(curElem && curElem.length)
					{
						selectedUsers.push(curElem);
					}
				}
				if(selectedUsers.length>0)
				{
					var users = [];
					selectedUsers.each(function(){
						var userName = $(this).attr("username");
						if(userName && !users.has(userName) && userName.length>0)
							users.push(userName);
					});
					if(!users || users.length==0)
					{
						jAlert("Please select user(s) to add to the group", "Message");
						return false;
					}
					var strMsg = "Total " + users.length + " user(s) selected : \"" + users.join(", ") + "\"";
					jPrompt("Select group :", "", "Pick A Group", function(value){
						if(value)
						{
							//Method to save group
							userManager.data.addUsersToGroup(value, users);
						}
					}, userManager.storage("availableGroups")
					, false
					,{
						messageToAppend : strMsg + "<br /><br />"
					});
				}
				else
				{
					jAlert("Please select user(s) to add to the group", "Message");
				}
				return false;
			});

			$("a.serverFilePickButton", $("#migrateUsersPopup, #importUsersDialog")).each(function(){
				$(this).click(function(){
					var curElem = $(this);
					curElem.crushFtpVFSBrowserPopup({
						type : curElem.attr("PickType") || 'file',
						callback : function(selectedPath){
							$("#" + curElem.attr("rel")).val(selectedPath).trigger("change");
						}
					});
					return false;
				});
			});

			/*Import Users*/
			var topNavigation = $("#topNavigation");
			var importUsersDialog = $("#importUsersDialog").form().dialog({
				autoOpen: false,
				height: 200,
				width: 700,
				modal: true,
				resizable: true,
				closeOnEscape: true,
				buttons: {
					"Cancel" : function(){
						$(this).dialog( "close" );
					},
					"Ok": function() {
						var params = {
							command : "importUsers",
							serverGroup : $("#userConnectionGroups").val() || "MainUsers"
						};
						importUsersDialog.find("input, select").each(function(){
							params[$(this).attr("id")] = encodeURIComponent($(this).val());
						});
						if(params.the_dir == "")
						{
							userManager.UI.growl("Import Users : ", "Please choose file/folder to continue user import.", true, 1500);
							$("#the_dir", importUsersDialog).focus();
							return false;
						}
						importUsersDialog.parent().block({
							message:  '<span><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-refresh"></span>Wait..</span>',
							css: {
								border: 'none',
								padding: '5px',
								backgroundColor: '#000',
								'-webkit-border-radius': '10px',
								'-moz-border-radius': '10px',
								opacity: .5,
								color: '#fff',
								'text-align':'center'
							}
						});
						userManager.data.serverRequest(params, function(msg){
							importUsersDialog.parent().unblock();
							importUsersDialog.dialog("close");
							userManager.UI.growl("Import Users : ", decodeURIComponent($(msg).find("response").text()), false, false);
						});
					}
				},
				beforeClose : function(){
					return true;
				}
			});

			$("a.importUsers", "#GUIInterface").unbind("click").bind("click", function(){
				importUsersDialog.dialog("open");
				topNavigation.hide();
				return false;
			});

			$("#migrateUsersPopup").form().dialog({
				autoOpen: false,
				height: 200,
				width: 600,
				title : "Migrate users data from one HD to another",
				modal: true,
				resizable: false,
				closeOnEscape: false,
				buttons: {
					"Cancel" : function(){
						$(this).dialog( "close" );
					},
					"Ok": function() {
						var params = {
							command : "migrateUsersVFS",
							serverGroup : $("#userConnectionGroups").val() || "MainUsers"
						};
						$("#migrateUsersPopup").find("input").each(function(){
							params[$(this).attr("id")] = $(this).val();
						});
						$("#migrateUsersPopup").parent().block({
							message:  '<span><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-refresh"></span>Wait..</span>',
							css: {
								border: 'none',
								padding: '5px',
								backgroundColor: '#000',
								'-webkit-border-radius': '10px',
								'-moz-border-radius': '10px',
								opacity: .5,
								color: '#fff',
								'text-align':'center'
							}
						});
						userManager.data.serverRequest(params, function(msg){
							$("#migrateUsersPopup").parent().unblock();
							$("#migrateUsersPopup").dialog("close");
							userManager.UI.growl("Migrate users data from one HD to another", decodeURIComponent($(msg).find("response").text()), false, false);
						});
					}
				},
				open: function(){
					$("#migrateUsersPopup").find("input").each(function(){
						$(this).val("");
					});
				}
			});

			$("a.migrateUsersData", "#GUIInterface").unbind("click").bind("click", function(){
				$("#migrateUsersPopup").dialog("open");
				topNavigation.hide();
				return false;
			});

			$("a.convertUser", "#GUIInterface").unbind("click").bind("click", function(){
				var allUsers = $(this).hasClass("all");
				var obj = {
					command : "convertUsers",
					serverGroup : $("#userConnectionGroups").val() || "MainUsers",
					allUsers : allUsers
				};
				var allUsersInList = [];
				var usersInList = userList.find("li");
				if(usersInList.length>0)
				{
					usersInList.each(function(){
						allUsersInList.push($.trim($(this).attr("username")));
					});
				}

				obj.users = allUsersInList.join(";");

				if(!allUsers)
				{
					var usersFormatted = [];
					var selectedUsers = userList.find("li.ui-selected");
					if(selectedUsers.length>0)
					{
						selectedUsers.each(function(){
							usersFormatted.push($.trim($(this).attr("username")));
						});
					}
					if(usersFormatted.length>0)
					{
						if(usersFormatted.length == 1)
							obj.username = usersFormatted.join(";");
						else
						{
							obj.users = usersFormatted.join(";");
							obj.allUsers = true;
						}
					}
					else
					{
						jAlert("Please select users to convert", "Error");
						return false;
					}
				}
				userManager.methods.performServerAction($(this), obj, "Converting users to new format :");
				return false;
			});

			$("a.removeSelectedUsersFromGroup", "#GUIInterface").unbind("click").bind("click", function(){
				var groupSelectList = $("#groupSelectList", "#GUIInterface");
				var selectedGroup = groupSelectList.find("option:selected");
				if(selectedGroup.length>0)
				{
					if(selectedGroup.attr("rel")=="editable")
					{
						var groupName = selectedGroup.val();
						var selectedUsers = userList.find("li.ui-selected");
						if(selectedUsers.length>0)
						{
							var users = [];
							var usersFormatted = [];
							selectedUsers.each(function(){
								users.push($(this).closest("li").attr("username"));
								usersFormatted.push($.trim($(this).closest("li").attr("username")));
							});
							var strMsg = "Total " + selectedUsers.length + " user(s) selected : \"" + users.join(", ") + "\"";
							jConfirm("Are you sure you wish to remove selected users from this group : '" + groupName + "' ? <br /> <br/> (Users will not be deleted, just the group reference) <br /> <br />" + strMsg, "Confirm", function(value){
								if(value)
								{
									//Method to remove group
									var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
									userManager.UI.showLoadingIndicator(true);
									userManager.dataRepo.getGroupInfo("group", serverGroup, function(info, xml){
										if(info)
										{
											userManager.storage("groupInfo", info);
											userManager.storage("groupInfoXML", xml);

											var groupInfoXML = $(userManager.storage("groupInfoXML"));
											//Method to save group
											var xml = [];
											xml.push("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
											xml.push("<groups type=\"properties\">");
											var groupUsernameExists = false;
											if(groupInfoXML && groupInfoXML.length>0)
											{
												var allUsers = userManager.storage("users");
												if(allUsers && allUsers.length>0)
												{
													for(var i=0;i<allUsers.length;i++)
													{
														if(allUsers[i] && allUsers[i].text && allUsers[i].text.toString().toLowerCase() == groupName.toLowerCase())
														{
															groupUsernameExists = true;
															break;
														}
													}
												}
												groupInfoXML.find("result_item result_item").each(function(){
													var groupAndUsers = $(this).find("*[type='vector']").each(function(){
														var curGroupName = $(this).attr("name") || $(this).get(0).tagName;
														xml.push("<item name=\""+curGroupName+"\" type=\"vector\">");
														if($.trim(curGroupName).toLowerCase() == groupName.toLowerCase())
														{
															$(this).children().each(function(){
																if(!usersFormatted.has($.trim($(this).text())))
																{
																	xml.push("<item_subitem>"+$(this).text()+"</item_subitem>");
																}
																else
																{
																	if(groupUsernameExists)
																	{
																		userManager.data.addRemoveInheritanceDetailsFromUser($(this).text(), selectedGroup.val(), true, true);
																	}
																}
															});
														}
														else
														{
															$(this).children().each(function(){
																xml.push("<item_subitem>"+$(this).text()+"</item_subitem>");
															});
														}
														xml.push("</item>");
													});
												});
											}
											xml.push("</groups>");

											userManager.dataRepo.saveGroupInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
												if(data)
												{
													userManager.data.bindGroupDetails(true, true, groupName);
													var userList = userManager.storage("users");
													for(var i=0;i<userList.length;i++)
													{
														var curUser = userList[i];
														if(curUser && curUser.text && usersFormatted.has(curUser.text))
														{
															var groups = curUser.groups;
															if(!groups || !jQuery.isArray(groups))
															{
																groups = [];
															}
															groups.remove(groups.indexOf(groupName));
														}
													}
													userManager.UI.growl("Message : ", "Users \"" +users.join(", ")+ "\" removed from group \""+ groupName + "\"", false, 3000);
													groupSelectList.trigger("change");
													userManager.UI.hideLoadingIndicator();
												}
												else
												{
													userManager.UI.growl("Failure : ", data, true, true);
												}
												if (groupUsernameExists)
												{
													xml = userManager.data.buildInheritanceXML();
													userManager.UI.showLoadingIndicator(true);
													userManager.dataRepo.saveInheritanceInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
														if(data)
														{
															userManager.UI.growl("Message : ", "User's inheritance data saved", false, 3000);
															userManager.UI.hideLoadingIndicator();
															userManager.methods.removeUsersLocalStorage();
															userManager.removeStorage("CurrentUserInheritanceDetails");
															$("a.refresh", "#sideBar").trigger("click");
														}
														else
														{
															userManager.UI.growl("Failure : ", data, true, true);
														}
													});
												}
											});
										}
									});
								}
							});
						}
						else
						{
							jAlert("You must have a user selected to continue", "Message");
						}
					}
					else
					{
						jAlert("This group can not be modified", "Message");
					}
				}
				else
				{
					jAlert("You must select a group to continue", "Message");
				}
				return false;
			});

			$("#applyInheritance", "#GUIInterface").unbind().click(function(){
				var selectedInheritance = $("#selectedInheritance", "#GUIInterface");
				var removedInheritance = [];
				var user = userManager.storage("userName");
				selectedInheritance.find("input[type='checkbox']").each(function(){
					if(!$(this).is(":checked"))
					{
						removedInheritance.push($(this).attr("rel"));
					}
				});
				if(removedInheritance.length>0)
				{
					var userList = userManager.storage("users");
					if(userList && userList.length>0)
					{
						for(var i=0;i<userList.length;i++)
						{
							if(userList[i] && userList[i].text && userList[i].text.toString().toLowerCase() == user.toLowerCase())
							{
								var inheritance = userList[i].inheritance;
								inheritance = inheritance.diff(removedInheritance);
								userList[i].inheritance = inheritance;
								i = userList.length;
							}
						}
					}
				}

				var xml = userManager.data.buildInheritanceXML();
				userManager.UI.showLoadingIndicator(true);
				userManager.dataRepo.saveInheritanceInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
					if(data)
					{
						userManager.UI.growl("Message : ", "User's inheritance data saved", false, 3000);
						userManager.UI.hideLoadingIndicator();
						userManager.methods.removeUsersLocalStorage();
						userManager.removeStorage("CurrentUserInheritanceDetails");
						$("a.refresh", "#sideBar").trigger("click");
					}
					else
					{
						userManager.UI.growl("Failure : ", data, true, true);
					}
				});
				userManager.data.showInheritanceDataForUser(user);
			});

			$(".logout", "#myslidemenu").unbind().click(function(){
				userManager.methods.logout();
				return false;
			});

			$("#sideBar, #quickJump").form(true);

			$('#topNavigation').find("a").addClass("ui-state-default").bind('mouseover', function(){
				var item = $(this).addClass("ui-state-focus").closest("ul").parent().find("a:first").addClass("ui-state-focus");
				if(item.is("#menuIcon")){
					item.removeClass("ui-state-focus");
				}
			}).bind('mouseout',  function(){
				$(this).removeClass("ui-state-focus").closest("ul").parent().find("a:first").removeClass("ui-state-focus");
			});

			$("#cancelChanges", "#GUIInterface").unbind().click(function(){
				if(userManager.methods.hasPendingChanges())
					$("a.refresh", "#sideBar").trigger("click");
				return false;
			});

			$("#saveUserData", "#GUIInterface").unbind().click(function(evt, evtData){
				var elem = $(this);
				var fromSaveAndContniue = false;
				if(evtData)
				{
					fromSaveAndContniue = evtData.fromSaveAndContniue;
				}
				if($(".hasPendingCall").length>0)
				{
					window.pendingEncryptionCall = function(){
						elem.trigger("click");
					};
				}
				else
				{
					var hasError = false;
					$(".validate", "#GUIInterface").each(function(){
						if($(this).validateNow())
						{
							hasError = true;
						}
					})
					if(!hasError)
					{
						var xml = ["<?xml version=\"1.0\" encoding=\"UTF-8\"?> "];
						var vfs = panelSetup.generateVFSXML();
						var privs = panelSetup.generatePrivsXML();
						xml.push("<user type=\"properties\">");
						for(var i=0;i<userManager.panelsToLoad.length;i++)
						{
							var pluginName = userManager.panelsToLoad[i];
							if(pluginName)
							{
								var scriptToRun = "xml.push(panel" + pluginName + ".generateXML());"
								eval(scriptToRun);
							}
						}
						xml.push("</user>");
						xml = xml.join("");
						var username = $.trim(userManager.storage("userName"));
						var newUsername = $.trim($("#user_name", panelSetup._panel).val());
						var dataAction = "replace";
						var deleteUser = false;

						function continueSavingData()
						{
							userManager.UI.showLoadingIndicator({
								message : "Saving informaiton..",
								title : "Wait..."
							});
							userManager.dataRepo.saveUserInfo(xml, vfs, privs, newUsername, dataAction, function(data){
								if(data)
								{
									if(deleteUser)
									{
										userManager.dataRepo.saveUserInfo("<?xml version=\"1.0\" encoding=\"UTF-8\"?>", "<?xml version=\"1.0\" encoding=\"UTF-8\"?><vfs type=\"properties\"></vfs>", "<?xml version=\"1.0\" encoding=\"UTF-8\"?><permissions type=\"properties\"></permissions>", username, "delete", function(delData){
											if(delData)
											{
												var usersData = $.xml2json(delData, false);
												if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
												{
													userManager.methods.itemsChanged(false);
													userManager.data.copyUsersGroupInfo(username, newUsername, function(flag){
														if(flag)
														{
															userManager.data.copyUsersInheritanceInfo(username, newUsername, function(flag){
																userManager.UI.hideLoadingIndicator();
																if(flag)
																{
																	userManager.storage("userName", newUsername);
																	userManager.UI.growl("Message : ", "User settings saved", false, 3000);
																	$(".reloadUsersLink", "#sideBar").trigger("click");
																}
															}, true);
														}
														else
														{
															userManager.UI.hideLoadingIndicator();
														}
													}, true);
												}
												else
												{
													userManager.storage("userName", newUsername);
													userManager.UI.growl("Message : ", "User settings saved. Failed while removing user : " + username, true);
												}
											}
										});
									}
									else
									{
										userManager.methods.itemsChanged(false);
										userManager.UI.hideLoadingIndicator();
										userManager.UI.growl("Message : ", "User settings saved", false, 3000);
										if(fromSaveAndContniue)
										{
											if(evtData.callBack)
											{
												evtData.callBack(true);
											}
										}
									}
								}
								else
								{
									userManager.UI.hideLoadingIndicator();
									userManager.UI.growl("Failure : ", data, true, true);
									if(fromSaveAndContniue)
									{
										if(evtData.callBack)
										{
											evtData.callBack(false);
										}
									}
								}
							});

							/*$("#dialog-message" ).html("<textarea style=\"width:970px;height:600px\">"+unescape(xml)+ "\r\n" + unescape(vfs) + "\r\n" + unescape(privs) + "</textarea>").dialog({
								modal: true,
								minWidth : 1000,
								maxWidth : 1000,
								maxHeight : 600,
								buttons: {
									Ok: function() {
										$( this ).dialog( "close" );
									}
								}
							});*/
						}

						if(username.toLowerCase() != newUsername.toLowerCase())
						{
							dataAction = "new";
							deleteUser = true;
							var waitBoxOpen = false;
							jAlert("Checking user name availability. Please wait..", "Wait", function(){
								waitBoxOpen = false;
							}, {
								okButtonText : "Cancel"
							});
							waitBoxOpen = true;
							userManager.methods.checkUserNameAvailability(newUsername, function(available){
								if(available)
								{
									if(fromSaveAndContniue)
									{
										if(evtData.callBack)
										{
											evtData.callBack(false);
										}
									}
									jAlert("User already exist, please choose another name", "Message", function(){
										$("#user_name", panelSetup._panel).focus().select();
									});
								}
								else
								{
									if(waitBoxOpen)
									{
										$("#popup_container").find(".submitActionOk").trigger("click");
										userManager.methods.showInfoToUserAboutSpecialUser(newUsername, continueSavingData);
									}
								}
							});
						}
						else
						{
							continueSavingData();
						}
					}
					else
					{
						var top_val = $(".validationErrorMessage:first").offset().top;
						$('html, body').animate({ scrollTop: top_val - 120}, 200);
						if(fromSaveAndContniue)
						{
							if(evtData.callBack)
							{
								evtData.callBack(false);
							}
						}
					}
				}
				return false;
			});

			//Keep this line at the end of this method, it will bind click at the end of all bindings
			$("#topNavigation, ul#context-menu").find("a").click(function(){
				contextMenu.hide();
				$(document).trigger("click");
			});
		},
		growl : function(title, content, warning, expires){
			$("#growlContainer").notify({
				speed: 500,
				expires: expires
			});
			var handler = $("#growlContainer")
				.notify({ custom:true })
				.notify("create", { title:title, text:content });
			$(handler.element).removeClass("ui-state-error ui-state-highlight");
			if(warning)
			{
				$(handler.element).addClass("ui-state-error");
			}
			else
			{
				$(handler.element).addClass("ui-state-highlight");
			}
		},
		notification : function(msg, error){
			if(!msg)
			{
				$("#notification").hide();
				return;
			}
			if(error)
			{
				$("#notification").removeClass("ui-state-highlight").removeClass("ui-state-error").empty().html(msg).show().addClass("ui-state-error").prepend('<span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-alert"></span>');
			}
			else
			{
				$("#notification").removeClass("ui-state-highlight").removeClass("ui-state-error").empty().html(msg).show().addClass("ui-state-highlight").prepend('<span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-info"></span>');
			}
		},
		resizeSidebar : function()
		{
			var sideBar = $('#sideBar');
			var heightOfHeader = $('#header').height();
			var heightOfFooter = $('#footer').height();
			var windowHeight = $(window).height();
			var cHeight = windowHeight - heightOfHeader - heightOfFooter ;
			cHeight = cHeight > 270 ? cHeight : 270;
			sideBar.height(cHeight);
			cHeight = cHeight - 270;
			$("#userList").parent().height(cHeight);
		}
	},
	data:
	{
		serverRequest: function(dataToSubmit, callback, url)
		{
			url = url || userManager.ajaxCallURL;
			$.ajax({
				type: "POST"
				, url: url
				, data: dataToSubmit
				, success: function(msg){
					callback(msg);
				}
				, error: function(XMLHttpRequest, textStatus, errorThrown)
				{
					callback(false, XMLHttpRequest, textStatus, errorThrown);
				}
			});
		},
		getValueFromJson : function(item, node)
		{
			if(item && item[node])
			{
				return item[node];
			}
			else
			{
				return "";
			}
		},
		getTextContentFromPrefs : function(item, node)
		{
			if(item && item[node])
			{
				return item[node];
			}
			else
			{
				return "";
			}
		},
		getServerItem : function(key, callback, url)
		{
			url = url || userManager.ajaxCallURL;
			var obj = {command:"getServerItem",key:key};
			$.ajax({
				type: "POST"
				, url: url
				, data: obj
				, success: function(msg){
					callback(msg);
				}
			});
		},
		loadAllPrefs : function(callback)
		{
			this.getServerItem("server_settings", callback);
		},
		loadServerInfo : function(callback)
		{
			this.getServerItem("server_info", function(data){
				var items = false;
				if(data && typeof data.getElementsByTagName != "undefined")
				{
					if(data.getElementsByTagName("result_value") && data.getElementsByTagName("result_value").length > 0)
					{
						data = data.getElementsByTagName("result_value")[0];
						items = $.xml2json(data);
						userManager.methods.rebuildSubItems(items, "result_value");
						userManager.storage("serverInfo", items);
						if(items)
						{
							var versionInfo = "";
							if(items.version_info_str)
								versionInfo = items.version_info_str;
							if(items.sub_version_info_str)
							{
								var subversion = items.sub_version_info_str;
								if(subversion.indexOf("_")==0)
									subversion = subversion.substr(1, subversion.length);
								versionInfo += " Build : " + subversion;
								$("#crushVersionInfo").text(versionInfo);
							}
						}
						if(callback){
							callback(items);
							return;
						}
					}
				}
				if(callback){
					callback(items);
				}
				return;
			});
		},
		getXMLPrefsDataFromServer : function(dataKey, callback)
		{
			var items = [];
			userManager.data.loadAllPrefs(function(data){
				if(data.getElementsByTagName("result_value") && data.getElementsByTagName("result_value").length > 0)
				{
					data = data.getElementsByTagName("result_value")[0];
					items = $.xml2json(data);
					userManager.storage(dataKey, items);
					userManager.data.loadServerInfo();
					if(callback){
						callback(data);
					}
				}
			});
		},
		setXMLPrefs : function(dataKey, dataType, dataAction, entryData, callback)
		{
			var obj = {
				command:"setServerItem",
				key: dataKey,
				data_type: dataType,
				data_action: dataAction,
				data: entryData
			};
			$.ajax({
				type: "POST"
				, url: userManager.ajaxCallURL
				, data: obj
				, success: function(msg)
				{
					callback(msg);
				}
			});
		},
		updateLocalPrefs : function(data, key)
		{
			var dataJson = $.xml2json(data, true);
			if(dataJson)
			{
				var prefs = $(document).data("GUIXMLPrefs");
				if(key == "server_prefs")
				{
					for(var item in dataJson)
					{
						if(item.length && item.length>0 && dataJson[item].length && dataJson[item].length>0)
						{
							prefs[item] = dataJson[item];
						}
					}
				}
				else
				{
					prefs[key] = [dataJson];
				}
				$(document).data("GUIXMLPrefs", prefs);
			}
		},
		getSubValueFromPrefs : function(node)
		{
			var prefs = $(document).data("GUIXMLPrefs");
			if(prefs && prefs[node] && prefs[node][node + "_subitem"])
			{
				return prefs[node][node + "_subitem"];
			}
			else
			{
				return [];
			}
		},
		getTextContent : function(obj) {
			var obj2 = {};
			try {
				if (window.ActiveXObject) obj2.textContent = obj.text;
				else obj2.textContent = obj.textContent;
			}
			catch (ex) {}
			return obj2;
		},
		setInheritPropertyOfSection : function(field, attrToUse, dynamic)
		{
			var parentPanel = $(field).closest("fieldset");
			var chkBox = parentPanel.find("td.checkboxArea:first").find("input:checkbox:first");
			if(chkBox.closest("td").hasClass("noInherit") || parentPanel.hasClass("inheritSet")) return;

			var id = $(field).attr(attrToUse);
			if(dynamic)
			{
				id = attrToUse;
			}
			if(id)
			{
				if(typeof userManager.storage("currentUser").user[id] == "undefined")
				{
					userManager.UI.checkUnchekInput(chkBox, false);
					userManager.UI.disableUncheckedPanel(chkBox);
					parentPanel.addClass("inheritSet");
				}
				else
				{
					userManager.UI.checkUnchekInput(chkBox, true);
					userManager.UI.disableUncheckedPanel(chkBox);
				}
			}
		},
		bindValuesFromJson : function(_panel, curItem, attrToUse, voidInheritValSet)
		{
			var dataInheritedFrom = false;
			attrToUse = attrToUse || "id";
			_panel.find("input[type='text']:not(.ignoreBind),input[type='password']:not(.ignoreBind), textarea:not(.ignoreBind), select:not(.ignoreBind)").each(function(){
				if($(this).attr(attrToUse))
				{
					if(curItem)
					{
						var curData = userManager.methods.seperateValueAndInheritValue(userManager.data.getValueFromJson(curItem, $(this).attr(attrToUse)));
						var curVal = curData.value;
						dataInheritedFrom = curData.inherit || dataInheritedFrom || "default";

						if($(this).closest("fieldset").is(".notInheritable"))
						{
							dataInheritedFrom = false;
						}

						$(this).val(userManager.methods.decodeXML(curVal)).trigger("change");
						var parent = $(this).closest("fieldset").attr("inheritedFrom", dataInheritedFrom);
						if(!voidInheritValSet)
						{
							userManager.data.setInheritPropertyOfSection($(this), attrToUse);
							if(!dataInheritedFrom)
							{
								parent.removeAttr("inheritedFrom");
							}
							if(!dataInheritedFrom)
							{
								parent.find("legend").remove();
							}
							_panel.find("fieldset:not(.inheritSet)").show();
						}
						if(!parent.hasClass("inheritValSet") && dataInheritedFrom)
						{
							parent.addClass("inheritValSet").find("legend").text(dataInheritedFrom);
						}
					}
					else
					{
						$(this).val("");
					}
				}
			});
			_panel.find("input[type='checkbox']:not(.ignoreBind), input[type='radio']:not(.ignoreBind) ").each(function(){
				if($(this).attr(attrToUse))
				{
					if(curItem)
					{
						var curData = userManager.methods.seperateValueAndInheritValue(userManager.data.getValueFromJson(curItem, $(this).attr(attrToUse)));
						var curVal = curData.value;
						dataInheritedFrom = curData.inherit || dataInheritedFrom || "default";
						if($(this).is(".reverse"))
						{
							userManager.UI.checkUnchekInput($(this), curVal != "true");
						}
						else
						{
							userManager.UI.checkUnchekInput($(this), curVal == "true");
						}
					}
					else
					{
						if($(this).is(".reverse"))
						{
							userManager.UI.checkUnchekInput($(this), true);
						}
						else
						{
							userManager.UI.checkUnchekInput($(this), false);
						}
					}
					if($(this).closest("fieldset").is(".notInheritable"))
					{
						dataInheritedFrom = false;
					}

					var parent = $(this).closest("fieldset").attr("inheritedFrom", dataInheritedFrom);
					if(!voidInheritValSet)
					{
						if(!dataInheritedFrom)
						{
							parent.removeAttr("inheritedFrom");
						}
						if(!dataInheritedFrom)
						{
							parent.find("legend").remove();
						}
						userManager.data.setInheritPropertyOfSection($(this), attrToUse);
					}
					if(!parent.hasClass("inheritValSet") && dataInheritedFrom)
					{
						parent.addClass("inheritValSet").find("legend").text(dataInheritedFrom);
					}
				}
			});
			_panel.find(".liveData").each(function(){
				if($(this).attr(attrToUse))
				{
					if(curItem)
					{
						var curData = userManager.methods.seperateValueAndInheritValue(userManager.data.getValueFromJson(curItem, $(this).attr(attrToUse)));
						var curVal = curData.value;
						dataInheritedFrom = curData.inherit || dataInheritedFrom || "default";
						$(this).text(curVal);
					}
					else
					{
						$(this).text("");
					}
					if($(this).closest("fieldset").is(".notInheritable"))
					{
						dataInheritedFrom = false;
					}

					var parent = $(this).closest("fieldset").attr("inheritedFrom", dataInheritedFrom);
					if(!voidInheritValSet)
					{
						userManager.data.setInheritPropertyOfSection($(this), attrToUse);
						if(!dataInheritedFrom)
						{
							parent.removeAttr("inheritedFrom");
						}
						if(!dataInheritedFrom)
						{
							parent.find("legend").remove();
						}
					}
					if(!parent.hasClass("inheritValSet") && dataInheritedFrom)
					{
						parent.addClass("inheritValSet").find("legend").text(dataInheritedFrom);
					}
				}
			});
		},
		buildXMLToSubmitForm : function(_panel, includeRadio, attrToUse, ignoreNullValue, ignoreFalse)
		{
			attrToUse = attrToUse || "id";
			var xmlString = [];
			_panel.find("input[type='text']:not(.ignoreBind, .excludeXML),input[type='password']:not(.ignoreBind, .excludeXML), textarea:not(.ignoreBind, .excludeXML), select:not(.ignoreBind, .excludeXML)").each(function(){
				if($(this).attr(attrToUse))
				{
					var curVal = userManager.methods.htmlEncode($(this).val());
					if(!ignoreNullValue)
						xmlString.push("<"+$(this).attr(attrToUse)+">"+curVal+"</"+$(this).attr(attrToUse)+">");
					else if(curVal.length>0)
						xmlString.push("<"+$(this).attr(attrToUse)+">"+curVal+"</"+$(this).attr(attrToUse)+">");
				}
			});
			_panel.find("input[type='checkbox']:not(.ignoreBind, .excludeXML)").each(function(){
				if($(this).attr(attrToUse))
				{
					if($(this).is(".reverse"))
					{
						if(!ignoreFalse)
							xmlString.push("<"+$(this).attr(attrToUse)+">"+!$(this).is(":checked")+"</"+$(this).attr(attrToUse)+">");
						else if(!$(this).is(":checked"))
							xmlString.push("<"+$(this).attr(attrToUse)+">"+!$(this).is(":checked")+"</"+$(this).attr(attrToUse)+">");
					}
					else
					{
						if(!ignoreFalse)
							xmlString.push("<"+$(this).attr(attrToUse)+">"+$(this).is(":checked")+"</"+$(this).attr(attrToUse)+">");
						else if($(this).is(":checked"))
							xmlString.push("<"+$(this).attr(attrToUse)+">"+$(this).is(":checked")+"</"+$(this).attr(attrToUse)+">");
					}
				}
			});
			if(includeRadio)
			{
				_panel.find("input[type='radio']:not(.ignoreBind, .excludeXML)").each(function(){
					if($(this).attr(attrToUse))
					{
						if(!ignoreFalse)
							xmlString.push("<"+$(this).attr(attrToUse)+">"+$(this).is(":checked")+"</"+$(this).attr(attrToUse)+">");
						else if($(this).is(":checked"))
							xmlString.push("<"+$(this).attr(attrToUse)+">"+$(this).is(":checked")+"</"+$(this).attr(attrToUse)+">");
					}
				});
			}
			return xmlString.join("\r\n");
		},
		bindGroupDetails : function(reloadData, triggerChange, nameToSelect, callback)
		{
			function updateDetails()
			{
				var groupSelectList = $("#groupSelectList, #groupListToSelectForInheritance", "#GUIInterface").empty();
				var userList = userManager.storage("users");
				var groupInfoXML = $(userManager.storage("groupInfoXML"));
				var availableGroups = userManager.storage("availableGroups") || [];
				if(groupInfoXML && groupInfoXML.length>0)
				{
					groupInfoXML.find("result_item result_item").each(function(){
						var groupAndUsers = $(this).find("*[type='vector']").each(function(){
							var groupName = $(this).attr("name") || $(this).get(0).tagName;
							if(!availableGroups.has(groupName))
							{
								availableGroups.push(groupName);
							}
							groupSelectList.append("<option rel='editable' value='"+groupName+"'>"+groupName+"</option>");
							$(this).children().each(function(){
								var curUserName = $(this).text();
								for(var i=0;i<userList.length;i++)
								{
									var curUser = userList[i];
									if(curUser && curUser.text && curUser.text.toLowerCase() == curUserName.toLowerCase())
									{
										var groups = curUser.groups;
										if(!groups || !jQuery.isArray(groups))
										{
											groups = [];
										}
										if(!groups.has(groupName))
										{
											groups.push(groupName);
										}
										curUser.groups = groups;
										var curList = groupSelectList.find("option[value='"+groupName+"']");
										var curtentLoadedUserName = userManager.storage("userName");
										if(curtentLoadedUserName && $.trim(curtentLoadedUserName).toLowerCase() == $.trim(curUser.text).toLowerCase() && !curList.attr("processed"))
										{
											curList.text(" * " + groupName);
											curList.attr("processed", true);
										}
									}
								}
							});
						});
					});
				}
				userManager.storage("availableGroups", availableGroups);
				groupSelectList.prepend("<option value='notingroup'>Not In A Group</option>");
				groupSelectList.prepend("<option value='all'>All Users</option>");
				$("#groupSelectList", "#GUIInterface").val("all");
				$("#groupListToSelectForInheritance", "#GUIInterface").prepend("<option value=''>Pick a group</option>").val("");
				if(nameToSelect)
				{
					$("#groupSelectList", "#GUIInterface").val(nameToSelect);
				}
				if(triggerChange)
					groupSelectList.trigger("change");

				groupSelectList.append("<option value='#addnewgroup#'>Add new group</option>");

				if(callback)
					callback();
			}
			if(reloadData)
			{
				var userList = $("#userList", "#GUIInterface");
				userManager.UI.showIndicator(false, userList, "Wait..");
				var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
				userManager.dataRepo.getGroupInfo("group", serverGroup, function(info, xml){
					if(info)
					{
						userManager.UI.hideIndicator(false, userList);
						userManager.storage("groupInfo", info);
						userManager.storage("groupInfoXML", xml);
						updateDetails();
					}
				});
			}
			else
			{
				updateDetails();
			}
		},
		bindInheritanceDetails : function()
		{
			var userList = userManager.storage("users");
			var inheritanceInfoXML = $(userManager.storage("inheritanceInfoXML"));
			if(inheritanceInfoXML && inheritanceInfoXML.length>0)
			{
				inheritanceInfoXML.find("result_item result_item").each(function(){
					$(this).children().each(function(){
						var curelem = $(this);
						var curTag = "";
						if(curelem.is("item"))
						{
							curTag = curelem.attr("name");
						}
						else
						{
							curTag = curelem.get(0).tagName;
						}
						var curUserName = curTag;
						$(curelem).children().each(function(){
							for(var i=0;i<userList.length;i++)
							{
								var curUser = userList[i];
								if(curUser && curUser.text && curUser.text.toString().toLowerCase() == curUserName.toLowerCase())
								{
									var inheritance = curUser.inheritance;
									if(!inheritance || !jQuery.isArray(inheritance))
									{
										inheritance = [];
									}
									if(!inheritance.has($(this).text()))
										inheritance.push($(this).text());
									curUser.inheritance = inheritance;
								}
							}
						});
					});
				});
			}
		},
		showInheritanceDataForUser : function(user)
		{
			var userList = userManager.storage("users");
			var selectedInheritance = $("#selectedInheritance", "#GUIInterface").empty();
			var inheritance = [];
			userManager.removeStorage("CurrentUserInheritanceFrom");
			if(userList && userList.length>0)
			{
				for(var i=0;i<userList.length;i++)
				{
					if(userList[i] && userList[i].text && userList[i].text.toString().toLowerCase() == user.toLowerCase())
					{
						inheritance = userList[i].inheritance;
						i = userList.length;
					}
				}
			}
			if(inheritance && inheritance.length>0)
			{
				inheritance.sort();
				for(var i=0;i<inheritance.length;i++)
				{
					var curVal = inheritance[i];
					if(curVal)
					{
						selectedInheritance.append("&nbsp;<span rel='"+curVal+"'><input rel='"+curVal+"' checked type='checkbox' id='inheritance_"+curVal+"' /><label for='inheritance_"+curVal+"'> "+curVal+" </label></span>");
					}
				}
				inheritance.reverse();
			}
			userManager.storage("CurrentUserInheritanceFrom", inheritance);
			selectedInheritance.form();
		},
		fetchInheritanceDataForUser : function(callback){
			var inheritance = userManager.storage("CurrentUserInheritanceFrom");
			var inheritanceData = [];
			userManager.removeStorage("CurrentUserInheritanceDetails");
			if(inheritance)
			{
				var index = 0;
				function getUserData()
				{
					if(index>=inheritance.length)
					{
						if(callback)
						{
							userManager.storage("CurrentUserInheritanceDetails", inheritanceData);
							callback();
						}
					}
					else
					{
						var curUser = inheritance[index];
						userManager.dataRepo.getUserInfo(curUser, function(info, xml){
							index+=1;
							inheritanceData.push({info:info, xml:xml});
							getUserData();
						}, false
						, true);
					}
				}
				getUserData();
			}
			else
			{
				if(callback)
				{
					callback();
				}
			}
		},
		storeCurrentUserInfo : function(userName)
		{
			if(userName)
			{
				userManager.storage("userName", userName);
			}
			else
			{
				userManager.removeStorage("userName");
				$("#placeHolder").fadeOut();
				$("#welcomeNote").fadeIn("medium");
			}
		},
		addRemoveInheritanceDetailsFromUser : function(user, inheritanceUser, remove, rebind)
		{
			var userList = userManager.storage("users");
			for(var i=0;i<userList.length;i++)
			{
				var curUser = userList[i];
				if(curUser && curUser.text && curUser.text.toString().toLowerCase() == user.toLowerCase())
				{
					var inheritance = curUser.inheritance;
					if(!inheritance || !jQuery.isArray(inheritance))
					{
						inheritance = [];
					}
					if(!inheritance.has(inheritanceUser))
					{
						if(remove)
						{
							inheritance.remove(inheritance.indexOf(inheritanceUser));
						}
						else
						{
							inheritance.push(inheritanceUser);
							$("#applyInheritance", "#GUIInterface").trigger("click");
						}
					}
					else
					{
						if(remove)
						{
							inheritance.remove(inheritance.indexOf(inheritanceUser));
						}
						else
						{
							userManager.UI.growl("Message : ", "User '" +inheritanceUser + "'  already added to inherit from", false, 3000);
						}
					}
					curUser.inheritance = inheritance;
				}
			}
			if(rebind)
			{
				userManager.data.showInheritanceDataForUser(user);
			}
		},
		addUsersToGroup : function(selectedGroupName, users, callback)
		{
			var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
			userManager.UI.showLoadingIndicator(true);
			userManager.dataRepo.getGroupInfo("group", serverGroup, function(info, xml){
				if(info)
				{
					userManager.storage("groupInfo", info);
					userManager.storage("groupInfoXML", xml);
					var groupUsernameExists = false;

					var groupInfoXML = $(userManager.storage("groupInfoXML"));
					//Method to save group
					var xml = [];
					xml.push("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
					xml.push("<groups type=\"properties\">");

					if(groupInfoXML && groupInfoXML.length>0)
					{
						var allUsers = userManager.storage("users");
						if(allUsers && allUsers.length>0)
						{
							for(var i=0;i<allUsers.length;i++)
							{
								if(allUsers[i] && allUsers[i].text && allUsers[i].text.toString().toLowerCase() == selectedGroupName.toLowerCase())
								{
									groupUsernameExists = true;
									break;
								}
							}
						}

						groupInfoXML.find("result_item result_item").each(function(){
							var groupAndUsers = $(this).find("*[type='vector']").each(function(){
								var groupName = $(this).attr("name") || $(this).get(0).tagName;
								var addedUsers = [];
								xml.push("<item name=\""+groupName+"\" type=\"vector\">");
								$(this).children().each(function(){
									if($(this).text().length>0)
									{
										xml.push("<item_subitem>"+$(this).text()+"</item_subitem>");
										addedUsers.push($(this).text());
									}
								});
								if(typeof groupName != "undefined" && typeof selectedGroupName != "undefined" && $.trim(groupName).toUpperCase() == selectedGroupName.toUpperCase())
								{
									for(var j=0;j<users.length;j++)
									{
										if(!addedUsers.has(users[j]) && users[j] != undefined && users[j] != 'undefined')
										{
											xml.push("<item_subitem>"+users[j]+"</item_subitem>");
											if(groupUsernameExists && users[j].toUpperCase()!= selectedGroupName.toUpperCase())
											{
												userManager.data.addRemoveInheritanceDetailsFromUser(users[j], selectedGroupName, false, true);
											}
										}
									}
								}
								xml.push("</item>");
							});
						});
					}
					xml.push("</groups>");
					userManager.dataRepo.saveGroupInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
						if(data)
						{
							userManager.data.bindGroupDetails(true, true, selectedGroupName, callback);
							userManager.UI.growl("Message : ", "Users \"" +users.join(", ")+ "\" added to group \""+ selectedGroupName + "\"", false, 3000);
							userManager.UI.hideLoadingIndicator();
						}
						else
						{
							userManager.UI.growl("Failure : ", data, true, true);
						}
					});
					if (groupUsernameExists)
					{
						xml = userManager.data.buildInheritanceXML();
						userManager.UI.showLoadingIndicator(true);
						userManager.dataRepo.saveInheritanceInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
							if(data)
							{
								userManager.UI.growl("Message : ", "User's inheritance data saved", false, 3000);
								userManager.UI.hideLoadingIndicator();
								userManager.methods.removeUsersLocalStorage();
								userManager.removeStorage("CurrentUserInheritanceDetails");
								$("a.refresh", "#sideBar").trigger("click");
							}
							else
							{
								userManager.UI.growl("Failure : ", data, true, true);
							}
						});
					}
				}
			});
		},
		buildInheritanceXML : function()
		{
			//Method to save inheritance
			var xml = [];
			xml.push("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			xml.push("<inheritance type=\"properties\">");

			var usersList = userManager.storage("users");
			if(usersList && usersList.length>0)
			{
				for(var i=0;i<usersList.length;i++)
				{
					var curUserName = usersList[i].text;
					if(curUserName && curUserName.length>0)
					{
						var inheritanceData = usersList[i].inheritance;
						if(inheritanceData)
						{
							xml.push("<item name=\""+curUserName+"\" type=\"vector\">");
							for(var j=0;j<inheritanceData.length;j++)
							{
								xml.push("<item_subitem>"+inheritanceData[j]+"</item_subitem>");
							}
							xml.push("</item>");
						}
					}
				}
			}
			xml.push("</inheritance>");
			return xml;
		},
		copyUsersGroupInfo : function(sourceUser, newUser, callback, replace){
			if(!sourceUser ||  !newUser || !callback) return;
			sourceUser = sourceUser.toLowerCase();
			var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
			userManager.UI.showLoadingIndicator(true);
			userManager.dataRepo.getGroupInfo("group", serverGroup, function(info, xml){
				if(info)
				{
					userManager.storage("groupInfo", info);
					userManager.storage("groupInfoXML", xml);

					var groupInfoXML = $(userManager.storage("groupInfoXML"));
					//Method to save group
					var xml = [];
					xml.push("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
					xml.push("<groups type=\"properties\">");
					if(groupInfoXML && groupInfoXML.length>0)
					{
						groupInfoXML.find("result_item result_item").each(function(){
							var groupAndUsers = $(this).find("*[type='vector']").each(function(){
								var groupName = $(this).attr("name") || $(this).get(0).tagName;
								xml.push("<item name=\""+groupName+"\" type=\"vector\">");
								$(this).children().each(function(){
									if(replace)
									{
										if($(this).text().toLowerCase() == sourceUser)
										{
											xml.push("<item_subitem>"+newUser+"</item_subitem>");
										}
										else
										{
											if($(this).text())
												xml.push("<item_subitem>"+$(this).text()+"</item_subitem>");
										}
									}
									else
									{
										if($(this).text())
											xml.push("<item_subitem>"+$(this).text()+"</item_subitem>");

										if($(this).text().toLowerCase() == sourceUser)
										{
											xml.push("<item_subitem>"+newUser+"</item_subitem>");
										}
									}
								});
								xml.push("</item>");
							});
						});
					}
					xml.push("</groups>");
					userManager.dataRepo.saveGroupInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
						if(data)
						{
							callback(true);
						}
						else
						{
							callback(false);
							userManager.UI.growl("Failure : ", data, true, true);
						}
					});
				}
			});
		},
		copyUsersInheritanceInfo : function(sourceUser, newUser, callback, replace)
		{
			if(!sourceUser ||  !newUser || !callback) return;
			sourceUser = sourceUser.toLowerCase();
			//Method to save inheritance
			var xml = [];
			xml.push("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			xml.push("<inheritance type=\"properties\">");

			var usersList = userManager.storage("users");
			if(usersList && usersList.length>0)
			{
				for(var i=0;i<usersList.length;i++)
				{
					var curUserName = usersList[i].text;
					if(curUserName && curUserName.length>0)
					{
						var inheritanceData = usersList[i].inheritance;
						if(inheritanceData)
						{
							if(replace)
							{
								if(curUserName.toLowerCase() == sourceUser)
								{
									xml.push("<item name=\""+newUser+"\" type=\"vector\">");
									for(var j=0;j<inheritanceData.length;j++)
									{
										if(inheritanceData[j])
											xml.push("<item_subitem>"+inheritanceData[j]+"</item_subitem>");
									}
									xml.push("</item>");
								}
								else
								{
									xml.push("<item name=\""+curUserName+"\" type=\"vector\">");
									for(var j=0;j<inheritanceData.length;j++)
									{
										if(inheritanceData[j])
											xml.push("<item_subitem>"+inheritanceData[j]+"</item_subitem>");
									}
									xml.push("</item>");
								}
							}
							else
							{
								xml.push("<item name=\""+curUserName+"\" type=\"vector\">");
								for(var j=0;j<inheritanceData.length;j++)
								{
									if(inheritanceData[j])
										xml.push("<item_subitem>"+inheritanceData[j]+"</item_subitem>");
								}
								xml.push("</item>");
								if(curUserName.toLowerCase() == sourceUser)
								{
									xml.push("<item name=\""+newUser+"\" type=\"vector\">");
									for(var j=0;j<inheritanceData.length;j++)
									{
										if(inheritanceData[j])
											xml.push("<item_subitem>"+inheritanceData[j]+"</item_subitem>");
									}
									xml.push("</item>");
								}
							}
						}
					}
				}
			}
			xml.push("</inheritance>");
			userManager.UI.showLoadingIndicator(true);
			userManager.dataRepo.saveInheritanceInfo(xml.join("\r\n"), userManager.storage("userName"), "update", function(data){
				if(data)
				{
					if(!replace)
					{
						userManager.methods.removeUsersLocalStorage();
						userManager.removeStorage("CurrentUserInheritanceDetails");
						$("a.refresh", "#sideBar").trigger("click");
					}
					callback(true);
				}
				else
				{
					callback(false);
					userManager.UI.growl("Failure : ", data, true, true);
				}
			});
		}
	},
	storage : function(key, val)
	{
		if(key)
		{
			if(val)
			{
				return $(document).data(key, val);
			}
			else
			{
				return $(document).data(key);
			}
		}
		else
		{
			return false;
		}
	},
	removeStorage : function(key)
	{
		if($(document).data(key))
		{
			$(document).removeData(key);
		}
	},
	userLogin :
	{
		//Login status thread
		userLoginStatusCheckThread : function () {
			if (!userManager.loginStatusThreadInterval) {
				userManager.loginStatusThreadInterval = setInterval(
				function () {
					var targetUrl = window.location.toString();
					userManager.userLogin.bindUserName(function (response, username) {
						if (response == "failure") {
							if(userManager.placeHolder)
							{
								userManager.placeHolder.removeData("hasChanged");
							}
							window.location = targetUrl;
						}
					});
				}, 300000);
			}
		},
		//Bind user name
		bindUserName : function (callBack) { /* Data to POST to receive file listing */
			var obj = {
				command: "getUsername",
				random: Math.random()
			}; /* Make a call and receive list */
			var username = "anonymous";
			$.ajax({
				type: "POST",
				url: userManager.ajaxCallURL,
				data: obj,
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					errorThrown = errorThrown || "getUsername failed";
					userManager.UI.growl("Error : ", errorThrown, true, true);
					callBack("failure", username);
				},
				success: function (msg) {
					var responseText = msg;
					try {
						var response = msg.getElementsByTagName("response");
						response = userManager.data.getTextContent(response[0]).textContent;
						if (response == "success") {
							username = msg.getElementsByTagName("username");
							username = userManager.data.getTextContent(username[0]).textContent;
						}
						if (username == "anonymous" || username == "") {
							callBack("failure", username);
							return false;
						} else {
							$(document).data("username", username);
						}
					} catch (ex) {
						if (callBack) {
							callBack("failure", username);
							return false;
						}
					}
					if (callBack) {
						callBack(response, username);
					}
				}
			});
		}
	},
	dataRepo :
	{
		bindUserList : function (callback)
		{
			var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
			userManager.data.serverRequest({
				command: 'getUserList',
				serverGroup : serverGroup
			},
			function(data){
				if(data)
				{
					var users = $.xml2json(data, true);
					if(users && users.response_data && users.response_data.length>0 && users.response_data[0].user_list && users.response_data[0].user_list.length>0)
					{
						var userList = users.response_data[0].user_list[0].user_list;
						if(userList && userList.length>0 && userList[0].user_list_subitem && userList[0].user_list_subitem.length>0)
						{
							userList = userList[0].user_list_subitem;
							if(callback)
							{
								callback(userList);
							}
						}
					}
				}
				else
				{
					userManager.UI.growl("Failure", $(data).text(), true, true);
				}
			});
		},
		bindConnectionGroupList : function(allPrefs)
		{
			var prefs = $.xml2json(allPrefs, true);
			var userConnectionGroups = $("#userConnectionGroups").empty();
			if(prefs && prefs.server_groups && prefs.server_groups.length>0 && prefs.server_groups[0].server_groups_subitem && prefs.server_groups[0].server_groups_subitem.length>0)
			{
				userManager.methods.rebuildSubItems(prefs.server_groups, "server_groups");
				var serverGroupList = prefs.server_groups[0]["server_groups_subitem"];
				for(var i=0;i<serverGroupList.length;i++)
				{
					var name = serverGroupList[i].text;
					userConnectionGroups.append("<option val='"+name+"'>"+name+"</option>");
				}
			}
			else
			{
				userConnectionGroups.append("<option val='MainUsers'>MainUsers</option>");
			}
		},
		getUserInfo : function(user, callback, trackInfo, returnDataOnly) {
			var context = this;
			function getUserCall()
			{
				var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
				userManager.data.serverRequest({
					command: 'getUser',
					serverGroup : serverGroup,
					username : user
				},
				function(data){
					if(data)
					{
						var usersData = $.xml2json(data, false);
						if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
						{
							if(callback)
							{
								var userItems = usersData.response_data.user_items;
								if(!returnDataOnly)
								{
									userManager.storage("currentUser", userItems);
									userManager.storage("currentUserXML", data);
									if(trackInfo)
									{
										userManager.data.storeCurrentUserInfo(user);
										var selectedGroup = $("#groupSelectList").val();
										if(!selectedGroup || selectedGroup.length == 0) selectedGroup = "all";
										userManager.data.bindGroupDetails(false, false, selectedGroup);
									}
								}
								callback(userItems, data);
							}
						}
						else
						{
							userManager.UI.growl("Failure", $(data).text(), true, true);
							if(trackInfo)
							{
								userManager.data.storeCurrentUserInfo(false);
							}
							if(callback)
							{
								callback(false);
							}
						}
					}
					else
					{
						userManager.UI.growl("Failure", $(data).text(), true, true);
						if(trackInfo)
						{
							userManager.data.storeCurrentUserInfo(false);
						}
						if(callback)
						{
							callback(false);
						}
					}
				});
			}
			if($.trim(user).toLowerCase() == "default" || returnDataOnly)
			{
				getUserCall();
			}
			else
			{
				userManager.dataRepo.refreshDefaultUserData(function(info, xml){
					if(info)
					{
						getUserCall();
					}
					else
					{
						if(callback)
						{
							callback(false);
						}
					}
				});
			}
		},
		//Expects user name, action as new, update or delete, a callback function and a flag if to track current user or not
		saveUserInfo : function(user, vfs_items, permissions, userName, action, callback, noGrowl) {
			var context = this;
			var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
			var objData = {
				command: 'setUserItem',
				data_action : action || 'new',
				serverGroup : serverGroup,
				username : userName
			};
			if(action == "delete")
			{
				delete objData.username;
				objData.usernames = userName;
			}
			if(user)
			{
				objData.user = user;
				objData.xmlItem = "user";
			}
			if(vfs_items)
			{
				objData.vfs_items = vfs_items;
			}
			else
			{
				objData.vfs_items  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><vfs type=\"properties\"></vfs>";
			}
			if(permissions)
			{
				objData.permissions = permissions;
			}
			userManager.data.serverRequest(objData,
			function(data, XMLHttpRequest, textStatus, errorThrown){
				if(data)
				{
					var usersData = $.xml2json(data, false);
					if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
					{
						if(callback)
						{
							callback(data);
						}
					}
					else
					{
						if(!noGrowl)
						{
							userManager.UI.growl("Failure", $(data).text(), true, true);
						}
						if(callback)
						{
							callback(false, data);
						}
					}
				}
				else
				{
					if(!noGrowl)
					{
						userManager.UI.growl("Failure", $(data).text(), true, true);
					}
					if(callback)
					{
						callback(false, XMLHttpRequest, textStatus, errorThrown);
					}
				}
			});
		},
		saveGroupInfo : function(groupXML, userName, action, callback, noGrowl) {
			var context = this;
			var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
			var objData = {
				command: 'setUserItem',
				data_action : action || 'new',
				serverGroup : serverGroup,
				username : userName,
				xmlItem : "groups",
				groups : groupXML
			};
			userManager.data.serverRequest(objData,
			function(data, XMLHttpRequest, textStatus, errorThrown){
				if(data)
				{
					var usersData = $.xml2json(data, false);
					if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
					{
						if(callback)
						{
							callback(data);
						}
					}
					else
					{
						if(!noGrowl)
						{
							userManager.UI.growl("Failure", $(data).text(), true, true);
						}
						if(callback)
						{
							callback(false, data);
						}
					}
				}
				else
				{
					if(!noGrowl)
					{
						userManager.UI.growl("Failure", $(data).text(), true, true);
					}
					if(callback)
					{
						callback(false, XMLHttpRequest, textStatus, errorThrown);
					}
				}
			});
		},
		saveInheritanceInfo : function(inheritanceXML, userName, action, callback, noGrowl) {
			var context = this;
			var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
			var objData = {
				command: 'setUserItem',
				data_action : action || 'new',
				serverGroup : serverGroup,
				username : userName,
				xmlItem : "inheritance",
				inheritance : inheritanceXML
			};
			userManager.data.serverRequest(objData,
			function(data, XMLHttpRequest, textStatus, errorThrown){
				if(data)
				{
					var usersData = $.xml2json(data, false);
					if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
					{
						if(callback)
						{
							callback(data);
						}
					}
					else
					{
						if(!noGrowl)
						{
							userManager.UI.growl("Failure", $(data).text(), true, true);
						}
						if(callback)
						{
							callback(false, data);
						}
					}
				}
				else
				{
					if(!noGrowl)
					{
						userManager.UI.growl("Failure", $(data).text(), true, true);
					}
					if(callback)
					{
						callback(false, XMLHttpRequest, textStatus, errorThrown);
					}
				}
			});
		},
		getGroupInfo : function(type, serverGroup, callback) {
			var context = this;
			type = type || "group";
			serverGroup = serverGroup || "MainUsers";
			userManager.data.serverRequest({
				command: 'getUserXML',
				serverGroup : serverGroup,
				xmlItem : type
			},
			function(data){
				if(data)
				{
					var usersData = $.xml2json(data, false);
					if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
					{
						var response = usersData.response_data;
						if(callback)
						{
							callback(response, data);
						}
					}
				}
				else
				{
					userManager.UI.growl("Failure", $(data).text(), true, true);
					if(callback)
					{
						callback(false);
					}
				}
			});
		},
		refreshDefaultUserData : function(callback){
			userManager.dataRepo.getUserInfo("default", function(info, xml){
				if(info)
				{
					userManager.storage("defaultUser", info);
					userManager.storage("defaultUserXML", xml);
					if(callback)
					{
						callback(info, xml);
					}
				}
				else
				{
					if(callback)
					{
						callback(false);
					}
				}
			});
		}
	},
	methods :
	{
		initGUI : function(){
			var mainServerInstance = $.cookie("mainServerInstance");
			if(mainServerInstance!=null && mainServerInstance.length>0 && mainServerInstance.toLowerCase()!= "main")
				userManager.ajaxCallURL = userManager.ajaxCallURLBase + mainServerInstance + "/";

			window.onbeforeunload = userManager.methods.confirmExit;
			userManager.placeHolder = $("#placeHolder");
			userManager.GUIInterface = $("#GUIInterface");
			$(document).data("pageTitle", document.title);
			userManager.methods.prepareDataRepo(function(){
				userManager.methods.loadPanels(false, function(){
					userManager.methods.buildUserList();
					userManager.UI.initEvents();
					userManager.data.bindGroupDetails();
					userManager.data.bindInheritanceDetails();
					userManager.UI.hideLoadingIndicator();
					$("#filterUserInList", "#GUIInterface").focus().select();
					if(userManager.defaultUserToLoad.length>0)
					{
						$("#userList").find("li[userName='"+userManager.defaultUserToLoad+"']").trigger("dblclick");
					}
				});
			});

			/*Session checker will get version information, based on it new features will be show/hide/initiated*/
			$(".enterpriseFeature").hide();
			$("#SessionSeconds").sessionChecker({
				callBack:function(){
					if (($(document).data("crushftp_version")+"").indexOf("6") >= 0) //show new features
					{
						if (($(document).data("crushftp_enterprise")+"") * 1 > 0) //show new features
						{
							$(".enterpriseFeature").show();
						}
					}
					else
					{
						userManager.userLogin.userLoginStatusCheckThread();
					}
				}
			});
		},
		inheritDataFromUser : function(target, copyFrom){
			if(!target || !copyFrom)return;
			var inhUser = copyFrom.user_name;
			for(obj in copyFrom)
			{
				if(target && typeof target[obj] == "undefined")
				{
					target[obj] = copyFrom[obj];
					if(typeof target[obj] == "string")
						target[obj] = target[obj].toString() + "|||||" + inhUser;
					else if(typeof target[obj] == "object")
						target[obj]["inheritedFrom"] = inhUser;
				}
			}
			return target;
		},
		//Performs varions server actions on buttons
		performServerAction : function(elem, data, title, callback)
		{
			if(elem.attr("disabled"))return false;
			elem.block({
				message:  'Wait..',
				css: {
					border: 'none',
					padding: '0px 10px',
					backgroundColor: '#000',
					'-webkit-border-radius': '10px',
					'-moz-border-radius': '10px',
					opacity: .5,
					color: '#fff',
					'text-align':'left'
				}
			}).attr("disabled", "disabled");
			userManager.data.serverRequest(data, function(msg){
				elem.unblock().removeAttr("disabled");
				if(callback)
				{
					callback($(msg).find("response"));
				}
				else
				{
					title = title || "Message from server, action : " + data.command;
					userManager.UI.growl(title, decodeURIComponent($(msg).find("response").text()), false, false);
				}
			});
			return false;
		},
		/*Fetches user list, and default users data and stores in local storage*/
		prepareDataRepo : function(callback, dontBindGroups){
			var logoElem = $("#logo", "#header").hide();
			var mainServerInstance = $.cookie("mainServerInstance");
			userManager.data.getXMLPrefsDataFromServer("GUIXMLPrefs", function(allPrefs){
				userManager.data.serverRequest({
					command: 'getServerItem',
					key: "server_settings/server_list",
					random: Math.random()
				},
				function(data){
					var _mainServerInstance = $("#mainServerInstance").empty();
					if(data)
					{
						$(data).find("result_value_subitem").each(function(){
							var type = $(this).find("serverType").text();
							if(type.toLowerCase() == "dmz")
							{
								var instance = $(this).find("server_item_name").text();
								if(!instance) instance = $(this).find("ip").text() + ":" + $(this).find("port").text();
								if(instance && instance.length>0)
								{
									if(instance.toLowerCase() == "main")
										_mainServerInstance.append("<option value=''>"+instance+"</option>");
									else
										_mainServerInstance.append("<option value='"+instance+"'>"+instance+"</option>");
								}
							}
						});
						if(_mainServerInstance.find("option").length>0)
						{
							_mainServerInstance.prepend("<option value=''>Main</option>")
							if(mainServerInstance != null)
							{
								if(_mainServerInstance.find("option[value='"+mainServerInstance+"']").length>0)
								{
									if(mainServerInstance.length>0 && mainServerInstance.toLowerCase()!= "main")
										userManager.ajaxCallURL = userManager.ajaxCallURLBase + mainServerInstance + "/";
									_mainServerInstance.val(mainServerInstance);
								}
								else
								{
									userManager.ajaxCallURL = userManager.ajaxCallURLBase;
									_mainServerInstance.val("");
									var options = {
										path: '/'
									};
									$.cookie("mainServerInstance", null);
									$.cookie("mainServerInstance", "", options);
								}
							}
						}
						else
						{
							_mainServerInstance.parent().remove();
						}
					}
					userManager.data.serverRequest({
						command: "getUserInfo",
						path : "/",
						random: Math.random()
					}, function(xmlData){
						var userInfo = $.xml2json(xmlData, false);
						userManager.isUserAdmin = false;
						userManager.isUserLimitedAdmin = false;
						if(userInfo && userInfo.user_priv_options)
						{
							var privs = userInfo.user_priv_options;
							if(privs.indexOf("(CONNECT)")>=0)
							{
								userManager.isUserAdmin = true;
							}
							else if(privs.indexOf("(USER_ADMIN)")>=0)
							{
								userManager.isUserLimitedAdmin = true;
								$(".adminOnly").remove();
							}
						}
						var customizations = [];
						var logo = "";
						$(xmlData).find("customizations_subitem").each(function(){
							var curObj = {
								key : $(this).find("key").text(),
								value : $(this).find("value").text()
							};
							customizations.push(curObj);
							if(curObj.key && curObj.key.toLowerCase() == "logo")
							{
								logo = curObj.value;
							}
						});
						if(logo)
						{
							if(logo.toLowerCase().indexOf("http://")<0 && logo.toLowerCase().indexOf("https://")<0)
							{
								logo = "/WebInterface/images/" + logo;
							}
							if(logoElem.find("img").length>0)
								logoElem.find("img").replaceWith("<img src='" + logo+ "' />");
							else
								logoElem.append("<img src='" + logo + "' />");
						}
						logoElem.show();
						if(!dontBindGroups)
							userManager.dataRepo.bindConnectionGroupList(allPrefs);
						userManager.dataRepo.bindUserList(function(userList){
							if(userList)
							{
								userManager.storage("users", userList);
								//load Default user data from server
								userManager.dataRepo.refreshDefaultUserData(function(info, xml){
									if(info)
									{
										//Get groups information
										var serverGroup = $("#userConnectionGroups").val() || "MainUsers";
										userManager.dataRepo.getGroupInfo("group", serverGroup, function(info, xml){
											if(info)
											{
												userManager.storage("groupInfo", info);
												userManager.storage("groupInfoXML", xml);
												// Get inheritance information
												userManager.dataRepo.getGroupInfo("inheritance", serverGroup, function(info, xml){
													if(info)
													{
														userManager.storage("inheritanceInfo", info);
														userManager.storage("inheritanceInfoXML", xml);
														if(callback)
														{
															callback();
														}
													}
												});
											}
										});
									}
									else
									{
										userManager.UI.hideLoadingIndicator();
									}
								});
							}
							else
							{
								userManager.UI.hideLoadingIndicator();
							}
						});
					});
				}, userManager.ajaxCallURLBase);
			});
		},
		removeUsersLocalStorage : function()
		{
			userManager.removeStorage("currentUserDirPrivs");
			userManager.removeStorage("currentUserDirPrivsDefault");
			userManager.removeStorage("currentUserInherited");
			userManager.removeStorage("currentUsersLowerLevelsData");
			$("#root_dir", panelSettings._panel).removeClass("excludeXML");
			panelSetup.loadUser = false;
		},
		refreshUsersFromServer : function(callback)
		{
			userManager.dataRepo.bindUserList(function(userList){
					if(userList)
					{
						userManager.storage("users", userList);
					}
					if(callback)
					{
						callback();
					}
			});
		},
		showRefreshButton : function()
		{
			var userListPanel = $("#userList");
			var active = userListPanel.find("li.userSelected");
			if(active && active.length>0)
			{
				if(active.find("a.refresh").length>0)return;

				userListPanel.find("a.refresh").remove();
				active.append("<a class='refresh' title='Refresh user data'></a>");
				active.find("a.refresh").click(function(e){
					userManager.UI.showIndicator(true);
					userManager.methods.loadUserInfo($(this).closest("li").attr("userName"), true, function(){
						userManager.UI.hideIndicator(true);
						userManager.methods.itemsChanged(false);
					}, true, true);
					e.stopPropagation();
					e.preventDefault();
				});
			}
			else
			{
				$("#quickJump", "#GUIInterface").hide();
				$("#userSpecificButtons", "#GUIInterface").hide();
			}
		},
		/*Builds list of users and shows in right panel*/
		buildUserList : function(userList, name, group, inheritance){
			var users = userList || userManager.storage("users");
			var userListPanel = $("<ul></ul>");
			group = group || "all";
			$("#groupSelectList").val(group);
			inheritance = inheritance || "";
			var curtentUserName = userManager.storage("userName");
			for(var i=0; i<users.length;i++)
			{
				if(name)
				{
					var curVal = users[i].text.toLowerCase();
					if(curVal.indexOf(name.toLowerCase())>=0)
					{
						if(userListPanel.find("li[userName='" + users[i].text + "']").length==0)
						{
							userListPanel.append("<li userName='" + users[i].text + "'><span class='user'>" + users[i].text + "</span></li>");
						}
					}
				}
				else if(group && !inheritance)
				{
					var groups = users[i].groups;
					if(group == "all")
					{
						userListPanel.append("<li userName='" + users[i].text + "'><span class='user'>" + users[i].text + "</span></li>");
					}
					else if(group == "notingroup")
					{
						if(!groups || groups.length==0)
						{
							userListPanel.append("<li userName='" + users[i].text + "'><span class='user'>" + users[i].text + "</span></li>");
						}
					}
					else
					{
						if(groups && groups.length>0 && groups.has(group))
						{
							userListPanel.append("<li userName='" + users[i].text + "'><span class='user'>" + users[i].text + "</span></li>");
						}
					}
				}
				else if(inheritance)
				{
					var inheritanceInfo = users[i].inheritance;
					inheritance = inheritance.toLowerCase();
					if(inheritanceInfo && inheritanceInfo.length>0)
					{
						for(var j=0; j< inheritanceInfo.length;j++)
						{
							var curVal = inheritanceInfo[j].toLowerCase();
							if(curVal.indexOf(inheritance)>=0)
							{
								if(userListPanel.find("li[userName='" + users[i].text + "']").length==0)
								{
									userListPanel.append("<li userName='" + users[i].text + "'><span class='user'>" + users[i].text + "</span></li>");
								}
							}
						}
					}
				}
			}

			function continueBinding()
			{
				var usersList = $("#userList").empty();
				usersList.append(userListPanel.children());
				userListPanel = usersList;
				$("li" , userListPanel).addClass("ui-widget-content");

				$("#userListedCount").text(userListPanel.find("li:visible").length);

				var selectedElem  = userListPanel.find("li[userName='"+curtentUserName+"']").addClass("ui-state-active ui-selected userSelected");
				userManager.UI.checkUnchekInput(selectedElem.find("input[type='checkbox']"), true);
				userManager.methods.showRefreshButton();
				if(selectedElem && selectedElem.length>0)
				{
					userListPanel.scrollTo(selectedElem);
				}
				else
				{
					userManager.data.storeCurrentUserInfo(false);
				}

				var localDelay = (function () {
					var timer = 0;
					return function (callback, ms) {
						clearTimeout(timer);
						timer = setTimeout(callback, ms);
					};
				})();

				usersList.selectableAdvanced("destroy");

				usersList.selectableAdvanced({
					remove : function(event, ui) {
						$("#deleteUser", "#GUIInterface").trigger("click");
						return false;
					},
					change : function(event, ui)
					{
						localDelay(function(){
							var selected = usersList.find(".ui-selected");
							if($(ui.selection).length==1)
							{
								userManager.methods.userSelected($(ui.selection).filter(":first"));
							}
						}, 500);
						return false;
					},
					onEnter : function(event)
					{
						var selected = usersList.find("li.ui-state-focus").filter(":last");
						userManager.methods.userSelected(selected);
					},
					callOnSelection : function(itemLi)
					{
						return false;
					}
				}).find("li").unbind("dblclick").bind("dblclick", function(){
					var selected = $(this);
					userManager.methods.userSelected(selected);
				});
			}

			if(userManager.methods.hasPendingChanges() && curtentUserName && userListPanel.find("li[userName='"+curtentUserName+"']").length == 0)
			{
				jConfirm("If you navigate away, you will loose your unsaved changes. Do you want to continue?", "Confirm", function(value){
					if(value)
					{
						continueBinding();
						userManager.methods.itemsChanged(false);
					}
					else
					{
						userManager.UI.hideIndicator(true);
					}
				},
				{
					prependButtons : [{
						button : '<a href="javascript:void(0);" id="popup_continue" class="button" style="margin-right:10px;"><span style="display:inline-block;margin:-1px 3px 0px -7px;float:left;" class="pointer ui-icon ui-icon-disk"></span><span class="submitActionSaveAndContinue">Save & Continue</span></a>&nbsp;&nbsp;',
						clickEvent : function(){
							$("#saveUserData", "#GUIInterface").trigger("click", [{fromSaveAndContniue:true, callBack : function(flag){
								if(flag)
								{
									$("#popup_cancel").click();
									continueBinding();
								}
								else
								{
									$("#popup_cancel").click();
								}
							}}]);
						}
					}],
					okButtonText : "Discard Changes",
					okButtonClassAdd : "ui-icon-trash"
				});
			}
			else
			{
				continueBinding();
			}
		},
		userSelected : function(selected, nofocus)
		{
			userManager.methods.loadUserInfo(selected.attr("userName"), false, function(){
				selected.parent().find(".userSelected").removeClass("userSelected");
				selected.addClass("userSelected");
				userManager.methods.itemsChanged(false);
			}, nofocus);
		},
		/*Builds list of users to pick up based on selected group*/
		pickupUserFromGroup : function(group){
			var users = userManager.storage("users");
			var curtentUserName = userManager.storage("userName");
			var userListFiltered = [];
			group = group || "all";
			for(var i=0; i<users.length;i++)
			{
				var groups = users[i].groups;
				var userName = users[i].text;
				if(userName.toLowerCase() != curtentUserName.toLowerCase() && !userListFiltered.has(userName))
				{
					if(group == "all")
					{
						userListFiltered.push(userName);
					}
					else if(group == "notingroup")
					{
						if(!groups || groups.length==0)
						{
							userListFiltered.push(userName);
						}
					}
					else
					{
						if(groups && groups.length>0 && groups.has(group))
						{
							userListFiltered.push(userName);
						}
					}
				}
			}
			if(userListFiltered && userListFiltered.length>0)
			{
				jPrompt("Pick a user to inherit from :", "", "Pick A User", function(value){
					if(value)
					{
						userManager.data.addRemoveInheritanceDetailsFromUser(curtentUserName, value, false, true);
					}
				}, userListFiltered
				, false,
				{
					messageToAppend : "<div class='smallFont' style='margin:10px 0;'>(Note : Current user is not shown in the list)</div>"
				});
			}
			else
			{
				jAlert("No users available for selected group!!", "Message", function(){
					$("#groupListToSelectForInheritance", "#GUIInterface").focus().select();
				});
			}
		},
		/*Method to load user info on all panels*/
		loadUserInfo : function(userName, forced, callback, nofocus, noScroll){
			if(userManager.storage("userName") != userName || forced)
			{
				function continueLoadingUser()
				{
					userManager.UI.showIndicator(true);
					$("#eventActionPanel", panelEvents._panel).hide();
					userManager.dataRepo.getUserInfo(userName, function(info, xmlData){
						userManager.data.showInheritanceDataForUser(userName);
						userManager.data.fetchInheritanceDataForUser(function(){
							if(info)
							{
								userManager.methods.removeUsersLocalStorage();
								var defaultUserJson= $.xml2json(userManager.storage("defaultUserXML"));
								userManager.storage("defaultUserXML")
								var currentUserJson= $.xml2json(xmlData);
								var currentUserJsonDeep= $.xml2json(xmlData, true);

								//Override values from inherited users now
								var currentUserInheritanceDetails = userManager.storage("CurrentUserInheritanceDetails");
								if(currentUserInheritanceDetails)
								{
									for(var i=0;i<currentUserInheritanceDetails.length;i++)
									{
										var inheritedUserXML = currentUserInheritanceDetails[i].xml;
										if(inheritedUserXML)
										{
											var inheritedJsonDeep = $.xml2json(inheritedUserXML);
											userManager.methods.inheritDataFromUser(currentUserJson.response_data.user_items.user, inheritedJsonDeep.response_data.user_items.user);//deep copy of object and then overriding inherited users data with values of current users data
										}
									}
								}

								userManager.methods.inheritDataFromUser(currentUserJson.response_data.user_items.user, defaultUserJson.response_data.user_items.user); //deep copy of object and then overriding default users data with values of current users data

								//Generate lower level's data
								var lowerLevelsData = {};
								if(currentUserInheritanceDetails)
								{
									for(var i=0;i<currentUserInheritanceDetails.length;i++)
									{
										var inheritedUserXML = currentUserInheritanceDetails[i].xml;
										if(inheritedUserXML)
										{
											var inheritedJsonDeep = $.xml2json(inheritedUserXML);
											userManager.methods.inheritDataFromUser(lowerLevelsData, inheritedJsonDeep.response_data.user_items.user);//deep copy of object and then overriding inherited users data with values of current users data
										}
									}
								}

								userManager.methods.inheritDataFromUser(lowerLevelsData, defaultUserJson.response_data.user_items.user); //deep copy of object and then overriding default users data with values of current users data

								userManager.storage("currentUsersLowerLevelsData", lowerLevelsData);

								var properties = userManager.storage("defaultUser");
								//Override values from inherited users now
								var curUserData = $.extend(true, {}, info);
								try{
									var linkedVFS = [];
									var links = currentUserJsonDeep.response_data[0].user_items[0].user[0].linked_vfs[0].linked_vfs_subitem;
									if(links && links.length>0)
									{
										for(var i=0;i<links.length;i++)
										{
											if(links[i] && links[i].text)
											{
												linkedVFS.push(links[i].text);
											}
										}
									}
									userManager.methods.rebuildSubItems(curUserData.user.linked_vfs, "linked_vfs");
									curUserData.user.linked_vfs.linked_vfs_subitem = linkedVFS;
								}catch(ex){
								}
								if(currentUserInheritanceDetails)
								{
									for(var i=0;i<currentUserInheritanceDetails.length;i++)
									{
										var inheritedUserInfo = currentUserInheritanceDetails[i].info;
										if(inheritedUserInfo)
										{
											userManager.methods.inheritDataFromUser(curUserData.user, inheritedUserInfo.user); //deep copy of object and then overriding inherited users data with values of current users data
										}
									}
								}

								userManager.methods.inheritDataFromUser(curUserData.user, properties.user);//deep copy of object and then overriding default users data with values of current users data

								userManager.storage("currentUserInherited", curUserData);
								$(".inheritSet", "#GUIInterface").removeClass("inheritSet").show();
								$(".inheritValSet", "#GUIInterface").removeClass("inheritValSet");
								$("fieldset:hidden", userManager.placeHolder).show();
								userManager.methods.panelsDatabind(curUserData, currentUserJsonDeep);
								$(".validate", "#GUIInterface").crushValidator();
								if($("#placeHolder").is(":hidden"))
								{
									$("#welcomeNote").fadeOut();
									if(userManager.defaultPanelToShow)
									{
										$("#placeHolder").fadeIn("medium", function(){
											$("#quick_jump").val(userManager.defaultPanelToShow).trigger("change");
										});
									}
									else
									{
										$("#placeHolder").fadeIn("medium");
									}
								}
								if($("#showAllPanels").attr("state") && $("#showAllPanels").attr("state")=="hidden")
									$("#showAllPanels").trigger("click", [true]);
							}
							$("#quickJump", "#GUIInterface").show();
							$("#userSpecificButtons", "#GUIInterface").show();
							if(!nofocus)
								$("#quick_filter", "#GUIInterface").focus().select();
							if(callback)
							{
								callback();
							}
							userManager.methods.showRefreshButton();
							userManager.UI.updateHiddenSectionsCount();
							userManager.UI.hideIndicator(true);
							if(!noScroll)
							{
								$('html,body').animate({
										scrollTop: 100
								}, 500, false);
							}
						});
					}, true);
				}
				if(userManager.methods.hasPendingChanges())
				{
					jConfirm("If you navigate away, you will loose your unsaved changes. Do you want to continue?", "Confirm", function(value){
						if(value)
						{
							continueLoadingUser();
						}
						else
						{
							var userList = $("#userList");
							var selected = userList.find("li.userSelected");
							selected.parent().find(".ui-state-active").removeClass("ui-state-active");
							selected.parent().find(".ui-state-focus").removeClass("ui-state-focus");
							selected.parent().find(".ui-selected").removeClass("ui-selected");
							userManager.UI.hideIndicator(true);
						}
					},
					{
						prependButtons : [{
							button : '<a href="javascript:void(0);" id="popup_continue" class="button" style="margin-right:10px;"><span style="display:inline-block;margin:-1px 3px 0px -7px;float:left;" class="pointer ui-icon ui-icon-disk"></span><span class="submitActionSaveAndContinue">Save & Continue</span></a>&nbsp;&nbsp;',
							clickEvent : function(){
								$("#saveUserData", "#GUIInterface").trigger("click", [{fromSaveAndContniue:true, callBack : function(flag){
									if(flag)
									{
										$("#popup_cancel").click();
										continueLoadingUser();
									}
									else
									{
										$("#popup_cancel").click();
									}
								}}]);
							}
						}],
						okButtonText : "Discard Changes",
						okButtonClassAdd : "ui-icon-trash"
					});
				}
				else
				{
					continueLoadingUser();
				}
			}
		},
		/*Method passes merged user information to databind mehtod of each panels separately, event handled on panel's code*/
		panelsDatabind : function(userInfo, jsonDeep){
			for(var i=0; i<window.dataBindEvents.length;i++)
			{
				if(typeof window.dataBindEvents[i] == 'function')
				{
					window.dataBindEvents[i](userInfo, jsonDeep);
				}
			}
		},
		loadPanels : function(params, callback){
			var panels = $("#panels");
			userManager.UI.notification(false);
			function loadNextPanel(index)
			{
				index = index || 0;
				if(userManager.panelsToLoad.length>index)
				{
					var panel = userManager.panelsToLoad[index];
					index += 1;
					$.ajax({
						url : "panels/"+panel+"/index.html?random="+Math.random(),
						success : function(response) {
							var curPanel = $(response);
							panels.append(curPanel);
							buildButtons(curPanel);
							$(".tabs", curPanel).tabs();
							$.getScript("panels/"+panel+"/interface.js?random="+Math.random(), function() {
								var initParam = false;
								var initScript = "panel" + panel + ".init();";
								if(params && params.loadPlugin)
								{
									initParam = params.loadPlugin;
									initScript = "panel" + panel + ".init('"+initParam+"');";
								}
								try{
									eval(initScript);
									userManager.methods.initLayoutEvents(curPanel, panel);
									loadNextPanel(index);
								}
								catch(ex){
									if(ex && ex.toString() != "")
									{
										userManager.UI.growl("Error", panel + ".init(); " + ex, true);
										loadNextPanel(index);
									}
								}
							});
						},
						error : function(xhr)
						{
							var msg = "Sorry but there was an error: " + xhr.status + " " + xhr.statusText + " while loading panel : " + panel;
							userManager.UI.notification(msg, true);
							loadNextPanel(index);
						}
					});
				}
				else
				{
					if(callback)
					{
						callback();
					}
				}
			}
			loadNextPanel();
			return false;
		},
		initLayoutEvents : function(context, panel){
			var userList = $("#userList");
			context = context || userManager.placeHolder;
			userManager.methods.itemsChanged(false);
			context.form();
			$("#ui-datepicker-div").hide();
			context.unbind("changed").bind("changed", function(){
				userManager.methods.itemsChanged(true);
			});
			$("input", context).keypress(function (e) {
				if ((e.which && e.which == 13) || (e.keyCode && e.keyCode == 13)) {
					$('a#saveUserData', context).click();
					return false;
				} else {
					return true;
				}
			});
			vtip(context);
			$(".collapseHandle", context).each(function(){
				$(this).html(" [ - ]  " + panel + " (Click 'Show All' to see inherited items.) ");
				var fieldset = $(this).closest("fieldset").addClass("ui-state-default");
				$(this).click(function(){
					var dataDiv = $(this).parent().find("div.dataDiv");
					if(dataDiv.is(":hidden"))
					{
						dataDiv.show();
						$(this).html(" [ - ]  " + panel + " (Click 'Show All' to see inherited items.) ");
						fieldset.addClass("ui-state-default");
					}
					else
					{
						dataDiv.hide();
						$(this).html(" [ + ] " + panel);
						fieldset.removeClass("ui-state-default");
					}
				});
			});
			$("ol.selectable", context).selectable({
				selected: function(event, ui) {
					var selected = $(ui.selected);
					selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
					selected.addClass("ui-widget-header");
					if(selected.is("li"))
					{
						try{
							var events = $(this).data('events');
							if(events && events.onSelect)
							{
								$(this).trigger("onSelect", [$(this), selected]);
							}
						}
						catch(ex){
							if(ex && ex.toString() != "")
							{
								userManager.UI.growl("Error", ex, true);
							}
						}
					}
					return false;
				}
			});
			$("ol.selectableAdvanced", context).selectableAdvanced({
				select: function(event, ui) {
					var selected = $(ui.selection);
					selected.parent().find(".ui-state-highlight").removeClass("ui-state-highlight");
					try{
						var events = $(this).data('events');
						if(events && events.onSelect)
						{
							$(this).trigger("onSelect", [$(this), selected]);
						}
					}
					catch(ex){
						if(ex && ex.toString() != "")
						{
							userManager.UI.growl("Error", ex, true);
						}
					}
					return false;
				},
				change: function(event, ui) {
					var selected = $(ui.selection).filter(":last");
					selected.parent().find(".ui-state-highlight").removeClass("ui-state-highlight");
					try{
						var events = $(this).data('events');
						if(events && events.onSelect)
						{
							$(this).trigger("onSelect", [$(this), selected]);
						}
					}
					catch(ex){
						if(ex && ex.toString() != "")
						{
							userManager.UI.growl("Error", ex, true);
						}
					}
					return false;
				},
				remove : function(event, ui) {
					try{
						var events = $(this).data('events');
						if(events && events.onRemove)
						{
							$(this).trigger("onRemove", [$(this)]);
						}
					}
					catch(ex){
						if(ex && ex.toString() != "")
						{
							userManager.UI.growl("Error", ex, true);
						}
					}
					return false;
				}
			});
		},
		showInfoToUserAboutSpecialUser : function(userName, callback){
			if(userName.toLowerCase() == "anonymous")
			{
				jConfirm("This username is special and will allow any password. <br/>Are you sure  you want to allow any password?<br/>(Be sure to be secure if you do)", "Allow Anonymous User?", function(accepted){
					if(accepted)
					{
						callback();
					}
				});
			}
			else if(userName.toLowerCase() == "template")
			{
				jConfirm("Template is a special username that allows all usernames and passwords to login.<br/>Its like a catch all account... similar to anonymous logins.<br/><br/>Are you sure you want to use this username?", "Allow Anonymous User?", function(accepted){
					if(accepted)
					{
						callback();
					}
				});
			}
			else
			{
				callback();
			}
		},
		checkGroupNameExistance : function(groupName){
			var groupExist = false;
			var groupInfo = userManager.storage("groupInfoXML");
			if(groupInfo && $(groupInfo).find("result_item").length>0)
			{
				var groups = [];
				$(userManager.storage("groupInfoXML")).find("result_item:last").find("*[type='vector']").each(function(){
					groups.push($(this)[0].tagName.toLowerCase())
				});
				if(groups.has(groupName.toLowerCase()))
				{
					groupExist = true;
				}
			}
			return groupExist;
		},
		checkUserNameAvailability : function(user, callback)
		{
			var userExists = false;
			userManager.data.serverRequest({
				command: 'getUser',
				serverGroup : $("#userConnectionGroups").val() || "MainUsers",
				username : user
			},
			function(data){
				if(data)
				{
					var usersData = $.xml2json(data, false);
					if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
					{
						userExists = true;
					}
				}
				if(callback)
				{
					callback(userExists);
				}
			});
		},
		listenChanges : function(context){
			if(!context)return;
			context.find("input:not(.ignoreChange), select:not(.ignoreChange), textarea:not(.ignoreChange)").change(function(){
				userManager.methods.itemsChanged(true);
			});
			context.find("input[type='text']:not(.ignoreChange), textarea:not(.ignoreChange)").bind("textchange", function(){
				userManager.methods.itemsChanged(true);
			});
		},
		itemsChanged : function(flag){
			var context = userManager.placeHolder;
			if(context)
			{
				context.data("hasChanged", flag);
				if(!userManager.saveButton)
				{
					userManager.saveButton = $("#saveUserData");
				}
				if(flag)
				{
					userManager.saveButton.addClass("ui-state-hover");
				}
				else
				{
					userManager.saveButton.removeClass("ui-state-hover");
				}
			}
		},
		hasPendingChanges : function()
		{
			return userManager.placeHolder.data("hasChanged");
		},
		setPageTitle : function(title, append){
			if(title)
			{
				if(append)
				{
					title =  $(document).data("pageTitle") + " :: " + title;
				}
				document.title = title;
			}
			else if($(document).data("pageTitle"))
			{
				document.title = $(document).data("pageTitle");
			}
		},
		confirmExit : function(){
			if(userManager.placeHolder.data("hasChanged"))
			{
				return "If you navigate away, you will loose your unsaved changes. Do you want to continue?";
			}
		},
		//Generate random code based on length, numeric flag restricts code to be numbers only
		generateRandomPassword : function(length, numeric, possible){
			length = length || 8;
			var randomId = "";
			possible = possible || "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			if(numeric)
			{
				possible = "0123456789";
			}
			for( var i=0; i < length; i++ )
				randomId += possible.charAt(Math.floor(Math.random() * possible.length));
			return randomId;
		},
		dottedQuadToInt : function(ip)
		{
			if(!ip)return false;
			var parts = ip.split('.', 4);
			if(parts.length<4)return 0;
			var result = 0, base = 1;
			for (var i = 3;i>=0;i--)
			{
			   //validation
			   if (parts[i].length == 0 || parts[i].length > 3) return -1;
			   var segment = parseInt(parts[i],10);
			   if (isNaN(segment) || segment<0 || segment > 255) return -1;

			   //compute next segment
			   result += base * segment;
			   base = base << 8;
			}
			return result;
		},
		// Validate IP Address
		isValidIP : function(ip){
		   ip = userManager.methods.dottedQuadToInt(ip);
		   if (ip <= 0) return false;

		   //mulitcast range:
		   if (ip >= 3758096384 && ip <= 4026531839) return false;

		   //alternate way to check multicast:
		   if (ip >= userManager.methods.dottedQuadToInt('224.0.0.0') && ip <= userManager.methods.dottedQuadToInt('239.255.255.255')) return false;

		   return true;
		},
		//Validate numbers
		isNumeric : function(input){
			return ((input - 0) == input && input.length > 0);
		},
		//Validate Email address
		isValidEmail : function(email)
		{
			return (email.indexOf("@") > 0 && email.lastIndexOf(".") > email.indexOf("@"));
		},
		validateUserPassword : function(password, username)
		{
			if(!username)
			{
				username = $("#user_name", panelSetup._panel).val();
			}
			if(username && userManager.usernamesToIgnorePasswordValidation.has(username.toLowerCase()))return false;
			var messages = false;
			var minLength = $(document).data("GUIXMLPrefs").min_password_length || 8;
			var minNumeric = $(document).data("GUIXMLPrefs").min_password_numbers || 0;
			var minLower = $(document).data("GUIXMLPrefs").min_password_lowers || 0;
			var minUpper = $(document).data("GUIXMLPrefs").min_password_uppers || 0;
			var minSpecial = $(document).data("GUIXMLPrefs").min_password_specials || 0;
			if($(document).data("GUIXMLPrefs").blank_passwords == "false" && password.length == 0)
			{
				return messages;
			}
			var continueValidation = true;
			if($("#password", panelSetup._panel).hasClass("ignoreBlank"))
			{
				 continueValidation = (password.length>0);
			}
			if(continueValidation)
			{
				var passed = validatePassword(password, {
					length:   [minLength, 100],
					lower:    minLower,
					upper:    minUpper,
					numeric:  minNumeric,
					special:  minSpecial
				});
				if(!passed)
				{
					var rules = [];
					rules.push("<br /> - Must be of at least " + minLength +  " characters");
					if(minNumeric>0)
					{
						rules.push(" - Must contain at least " + minNumeric +  " numbers");
					}
					if(minLower>0)
					{
						rules.push(" - Must contain at least " + minLower +  " lower case characters");
					}
					if(minUpper>0)
					{
						rules.push(" - Must contain at least " + minUpper +  "  upper case characters");
					}
					if(minSpecial>0)
					{
						rules.push(" - Must contain at least " + minSpecial +  "  special characters (like "+userManager.specialCharactersInUserPass+")");
					}
					messages = [];
					messages.push("Password is not valid. Follow these rules for password : " + rules.join("<br/>"));
				}
			}
			return messages;
		},
		isDate : function(str, uk) {
		  var parms = str.split(/[\.\-\/]/);
		  var yyyy = parseInt(parms[2],10);
		  var mm   = parseInt(parms[1],10);
		  var dd   = parseInt(parms[0],10);
		  if(uk)
		  {
			mm   = parseInt(parms[0],10);
			dd   = parseInt(parms[1],10);
		  }
		  var date = new Date(yyyy,mm-1,dd,0,0,0,0);
		  return mm === (date.getMonth()+1) &&
				 dd === date.getDate() &&
			   yyyy === date.getFullYear();
		},
		//Check if input has special characters
		hasSpecialCharacters: function (input, charset){
			charset = charset || userManager.notAllowedChars;
			for (var i = 0; i < input.length; i++) {
				if (charset.indexOf(input.charAt(i)) != -1) {
					return true;
				}
			}
			return false;
		},
		removeSpecialChars : function(strVal)
		{
			return strVal.replace(/[^a-zA-Z 0-9]+/g,'');
		},
		//Check if input starts with number
		startsWithNumber : function(input){
		   input = input.replace(/(^\d+)(.+$)/i,'$1');
		   return !isNaN(input);
		},
		rebuildSubItems: function(item, name){
			if(item && name)
			{
				if(!item[name  + "_subitem"])
				{
					item[name  + "_subitem"] = [];
				}
				else if(!item[name  + "_subitem"].push)
				{
					var slab = item[name  + "_subitem"];
					item[name  + "_subitem"] = [slab];
				}
			}
		},
		seperateValueAndInheritValue : function(val)
		{
			var dataInheritedFrom = false;
			if(val.lastIndexOf("|||||")>=0)
			{
				dataInheritedFrom = val.substring(val.lastIndexOf("|||||"), val.length);
				dataInheritedFrom = dataInheritedFrom.replace("|||||","");
				val = val.substring(0, val.lastIndexOf("|||||"));
			}
			return {
				value : val,
				inherit : dataInheritedFrom
			};
		},
		showInheritValueLabel : function(field, dataInheritedFrom)
		{
			if(dataInheritedFrom)
			{
				var parent = $(field).closest("fieldset").attr("inheritedFrom", dataInheritedFrom);
				if(!parent.hasClass("inheritValSet") )
				{
					parent.addClass("inheritValSet").find("legend").text(dataInheritedFrom);
				}
			}
		},
		logout : function (elem) {
			$.ajax({
				type: "POST",
				url: userManager.ajaxCallURL,
				data: {
					command: "logout",
					random: Math.random()
				},
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					$.cookie("CrushAuth", "", {
						path: '/',
						expires: -1
					});
					document.location = document.location;
				},
				success: function (msg) {
					//Remove CrushAuth cookie and redirect to login page
					$.cookie("CrushAuth", "", {
						path: '/',
						expires: -1
					});
					document.location = document.location;
				}
			});
		},
		jsonToXML : function(json, flag, reverseEncode, noEncode)
		{
			if(!json) return "";
			var xml = [];
			for(var item in json)
			{
				var curItem = json[item];
				if(!$.isFunction(curItem))
				{
					if(curItem[0] && curItem[0][item + "_subitem"])
					{
						var subItem = curItem[0][item + "_subitem"];
						xml.push("<"+item+"  type=\"vector\">");
						if(subItem && subItem.length>0)
						{
							var itemTypeText = "";
							var subItemType = subItem[0].type;
							if(subItemType)
							{
								if($.isArray(subItemType) && subItemType.length>1)
								{
									itemTypeText = "type =\""+subItemType[1]+"\"";
								}
								else if(typeof subItemType === "string")
								{
									itemTypeText = "type =\""+subItemType+"\"";
								}
							}
							if($.isArray(subItem) && subItem.length>1)
							{
								for(var subSubItem in subItem)
								{
									var curSubItem = subItem[subSubItem];
									if(!$.isFunction(curSubItem))
									{
										xml.push("<"+item+"_subitem "+itemTypeText+">" + userManager.methods.jsonToXML(curSubItem, true, reverseEncode, noEncode) + "</"+item+"_subitem>");
									}
								}
							}
							else
							{
								xml.push("<"+item+"_subitem "+itemTypeText+">" + userManager.methods.jsonToXML(subItem, true, reverseEncode, noEncode) + "</"+item+"_subitem>");
							}
						}
						xml.push("</"+item+">");
					}
					else
					{
						var textVal = curItem;
						if($.isArray(textVal))
						{
							if(textVal.length>0)
							{
								textVal = textVal[0];
								if(typeof textVal.text != "undefined")
								{
									textVal = textVal.text;
								}
								else if(typeof textVal != "string")
								{
									textVal = "";
								}
							}
							else
							{
								textVal = "";
							}
						}
						else if(flag)
						{
							xml.push(userManager.methods.jsonToXML(curItem, false, reverseEncode, noEncode));
						}

						if(item.toLowerCase() != "type" && typeof curItem != "string")
						{
							if(typeof textVal =="string" && textVal != "undefined")
							{
								if(reverseEncode)
									xml.push("<"+item+">" + userManager.methods.htmlEncode(userManager.methods.decodeXML(textVal)) + "</"+item+">");
								else if(noEncode)
									xml.push("<"+item+">" + userManager.methods.decodeXML(textVal) + "</"+item+">");
								else
									xml.push("<"+item+">" + userManager.methods.htmlEncode(textVal) + "</"+item+">");
							}
						}
						else
						{
							if(typeof curItem != "string")
							{
								textVal = curItem[0].text;
								if(textVal && typeof textVal == "string"  && textVal != "undefined")
								{
									if(reverseEncode)
										xml.push("<"+item+">" + userManager.methods.htmlEncode(userManager.methods.decodeXML(textVal)) + "</"+item+">");
									else if(noEncode)
										xml.push("<"+item+">" + userManager.methods.decodeXML(textVal) + "</"+item+">");
									else
										xml.push("<"+item+">" + userManager.methods.htmlEncode(textVal) + "</"+item+">");
								}
							}
						}
					}
				}
			}
			return xml.join("\r\n");
		},
		xmlUnSafeCharsMapping : {
			'&': '&amp;',
			'"': '&quot;',
			"'" : '&apos;',
			'<': '&lt;',
			'>': '&gt;'
		},
		xmlUnSafeCharsMappingReverse : {
			'&amp;' : '&',
			'&quot;' : '"',
			'&apos;' : "'",
			'&lt;' : '<',
			'&gt;' : '>',
			'%2B' : '+',
			'%25' : '%'
		},
		xmlEncode : function(value)
		{
			if (value == undefined || value.length == 0) return value;
			 return value.replace(/([\&'"<>])/g, function(str, item) {
				return userManager.methods.xmlUnSafeCharsMapping[item];
			}).replace(/\%/g, "%25").replace(/\+/g, "%2B");
		},
		decodeXML : function(value)
		{
			if (value == undefined || value.length == 0) return value;
			 return value.replace(/(&quot;|&lt;|&gt;|&amp;|&apos;|%2B|%25)/g,
				function(str, item) {
					return userManager.methods.xmlUnSafeCharsMappingReverse[item];
			});
		},
		htmlEncode : function(value, encodeVal) {
			if(value != undefined && value.length>0)
			{
				var lines = value.split(/\r\n|\r|\n/);
				for (var i = 0; i < lines.length; i++) {
					if(lines[i] && typeof lines[i] == "string")
					lines[i] = userManager.methods.xmlEncode(lines[i]);
				}
				if(encodeVal)
					return encodeURIComponent(lines.join('\r\n'));
				else
					return lines.join('\r\n');
			}
			else
				return value;
		},
		encode : function(value) {
			return $('<div/>').text(value).html();
		},
		decode : function(value){
			return $('<div/>').html(value).text();
		},
		round : function(number, digits) {
            var multiple = Math.pow(10, digits);
            var rndedNum = Math.round(number * multiple) / multiple;
            return rndedNum;
        }
	}
};